<?php
/** Adminer Editor - Compact database editor
* @link https://www.adminer.org/
* @author Jakub Vrana, https://www.vrana.cz/
* @copyright 2009 Jakub Vrana
* @license https://www.apache.org/licenses/LICENSE-2.0 Apache License, Version 2.0
* @license https://www.gnu.org/licenses/gpl-2.0.html GNU General Public License, version 2 (one or other)
* @version 4.8.4
*/function
adminer_errors($Ib,$Jb){return!!preg_match('~^(Trying to access array offset on( value of type)? null|Undefined array key)~',$Jb);}error_reporting(6135);set_error_handler('adminer_errors',E_WARNING);$Wb=!preg_match('~^(unsafe_raw)?$~',ini_get("filter.default"));if($Wb||ini_get("filter.default_flags")){foreach(array('_GET','_POST','_COOKIE','_SERVER')as$W){$hf=filter_input_array(constant("INPUT$W"),FILTER_UNSAFE_RAW);if($hf)$$W=$hf;}}if(function_exists("mb_internal_encoding"))mb_internal_encoding("8bit");function
connection(){global$g;return$g;}function
adminer(){global$b;return$b;}function
version(){global$ca;return$ca;}function
idf_unescape($yc){if(!preg_match('~^[`\'"[]~',$yc))return$yc;$Qc=substr($yc,-1);return
str_replace($Qc.$Qc,$Qc,substr($yc,1,-1));}function
escape_string($W){return
substr(q($W),1,-1);}function
number($W){return
preg_replace('~[^0-9]+~','',$W);}function
number_type(){return'((?<!o)int(?!er)|numeric|real|float|double|decimal|money)';}function
remove_slashes($Qd,$Wb=false){if(function_exists("get_magic_quotes_gpc")&&get_magic_quotes_gpc()){while(list($w,$W)=each($Qd)){foreach($W
as$Kc=>$V){unset($Qd[$w][$Kc]);if(is_array($V)){$Qd[$w][stripslashes($Kc)]=$V;$Qd[]=&$Qd[$w][stripslashes($Kc)];}else$Qd[$w][stripslashes($Kc)]=($Wb?$V:stripslashes($V));}}}}function
bracket_escape($yc,$xa=false){static$Ye=array(':'=>':1',']'=>':2','['=>':3','"'=>':4');return
strtr($yc,($xa?array_flip($Ye):$Ye));}function
min_version($qf,$ad="",$h=null){global$g;if(!$h)$h=$g;$pe=$h->server_info;if($ad&&preg_match('~([\d.]+)-MariaDB~',$pe,$_)){$pe=$_[1];$qf=$ad;}return(version_compare($pe,$qf)>=0);}function
charset($g){return(min_version("5.5.3",0,$g)?"utf8mb4":"utf8");}function
script($xe,$Xe="\n"){return"<script".nonce().">$xe</script>$Xe";}function
script_src($mf){return"<script src='".h($mf)."'".nonce()."></script>\n";}function
nonce(){return' nonce="'.get_nonce().'"';}function
target_blank(){return' target="_blank" rel="noreferrer noopener"';}function
h($R){return
str_replace("\0","&#0;",htmlspecialchars($R,ENT_QUOTES,'utf-8'));}function
nl_br($R){return
str_replace("\n","<br>",$R);}function
checkbox($D,$X,$Ia,$Nc="",$td="",$d="",$Oc=""){$L="<input type='checkbox' name='$D' value='".h($X)."'".($Ia?" checked":"").($Oc?" aria-labelledby='$Oc'":"").">".($td?script("qsl('input').onclick = function () { $td };",""):"");return($Nc!=""||$d?"<label".($d?" class='$d'":"").">$L".h($Nc)."</label>":$L);}function
optionlist($F,$ke=null,$of=false){$L="";foreach($F
as$Kc=>$V){$xd=array($Kc=>$V);if(is_array($V)){$L.='<optgroup label="'.h($Kc).'">';$xd=$V;}foreach($xd
as$w=>$W)$L.='<option'.($of||is_string($w)?' value="'.h($w).'"':'').(($of||is_string($w)?(string)$w:$W)===$ke?' selected':'').'>'.h($W);if(is_array($V))$L.='</optgroup>';}return$L;}function
html_select($D,$F,$X="",$sd=true,$Oc=""){if($sd)return"<select name='".h($D)."'".($Oc?" aria-labelledby='$Oc'":"").">".optionlist($F,$X)."</select>".(is_string($sd)?script("qsl('select').onchange = function () { $sd };",""):"");$L="";foreach($F
as$w=>$W)$L.="<label><input type='radio' name='".h($D)."' value='".h($w)."'".($w==$X?" checked":"").">".h($W)."</label>";return$L;}function
select_input($c,$F,$X="",$sd="",$Jd=""){$Je=($F?"select":"input");return"<$Je$c".($F?"><option value=''>$Jd".optionlist($F,$X,true)."</select>":" size='10' value='".h($X)."' placeholder='$Jd'>").($sd?script("qsl('$Je').onchange = $sd;",""):"");}function
confirm($B="",$le="qsl('input')"){return
script("$le.onclick = function () { return confirm('".($B?js_escape($B):'Naozaj?')."'); };","");}function
print_fieldset($s,$Sc,$rf=false){echo"<fieldset><legend>","<a href='#fieldset-$s'>$Sc</a>",script("qsl('a').onclick = partial(toggle, 'fieldset-$s');",""),"</legend>","<div id='fieldset-$s'".($rf?"":" class='hidden'").">\n";}function
generate_linksbar($Wc){$Xc="<p class='links'>";foreach($Wc
as$w=>$y){if($w!==key(array_keys($Wc)))$Xc.="<span class='separator'>|</span>";$Xc.=$y;}$Xc.="</p>";return$Xc;}function
bold($Da,$d=""){return($Da?" class='active $d'":($d?" class='$d'":""));}function
odd($L=' class="odd"'){static$r=0;if(!$L)$r=-1;return($r++%2?$L:'');}function
js_escape($R){return
addcslashes($R,"\r\n'\\/");}function
json_row($w,$W=null){static$Xb=true;if($Xb)echo"{";if($w!=""){echo($Xb?"":",")."\n\t\"".addcslashes($w,"\r\n\t\"\\/").'": '.($W!==null?'"'.addcslashes($W,"\r\n\"\\/").'"':'null');$Xb=false;}else{echo"\n}\n";$Xb=true;}}function
ini_bool($Bc){$W=ini_get($Bc);return(preg_match('~^(on|true|yes)$~i',$W)||(int)$W);}function
sid(){static$L;if($L===null)$L=(SID&&!($_COOKIE&&ini_bool("session.use_cookies")));return$L;}function
set_password($Y,$P,$U,$I){$_SESSION["pwds"][$Y][$P][$U]=($_COOKIE["adminer_key"]&&is_string($I)?array(encrypt_string($I,$_COOKIE["adminer_key"])):$I);}function
get_password(){$L=get_session("pwds");if(is_array($L))$L=($_COOKIE["adminer_key"]?decrypt_string($L[0],$_COOKIE["adminer_key"]):false);return$L;}function
q($R){global$g;return$g->quote($R);}function
get_vals($J,$e=0){global$g;$L=array();$K=$g->query($J);if(is_object($K)){while($M=$K->fetch_row())$L[]=$M[$e];}return$L;}function
get_key_vals($J,$h=null,$se=true){global$g;if(!is_object($h))$h=$g;$L=array();$K=$h->query($J);if(is_object($K)){while($M=$K->fetch_row()){if($se)$L[$M[0]]=$M[1];else$L[]=$M[0];}}return$L;}function
get_rows($J,$h=null,$k="<p class='error'>"){global$g;$Wa=(is_object($h)?$h:$g);$L=array();$K=$Wa->query($J);if(is_object($K)){while($M=$K->fetch_assoc())$L[]=$M;}elseif(!$K&&!is_object($h)&&$k&&defined("PAGE_HEADER"))echo$k.error()."\n";return$L;}function
unique_array($M,$u){foreach($u
as$t){if(preg_match("~PRIMARY|UNIQUE~",$t["type"])){$L=array();foreach($t["columns"]as$w){if(!isset($M[$w]))continue
2;$L[$w]=$M[$w];}return$L;}}}function
escape_key($w){if(preg_match('(^([\w(]+)('.str_replace("_",".*",preg_quote(idf_escape("_"))).')([ \w)]+)$)',$w,$_))return$_[1].idf_escape(idf_unescape($_[2])).$_[3];return
idf_escape($w);}function
where($Z,$m=array()){global$g,$v;$L=array();foreach((array)$Z["where"]as$w=>$W){$w=bracket_escape($w,1);$e=escape_key($w);$L[]=$e.($v=="sql"&&is_numeric($W)&&preg_match('~\.~',$W)?" LIKE ".q($W):($v=="mssql"?" LIKE ".q(preg_replace('~[_%[]~','[\0]',$W)):" = ".unconvert_field($m[$w],q($W))));if($v=="sql"&&preg_match('~char|text~',$m[$w]["type"]??null)&&preg_match("~[^ -@]~",$W))$L[]="$e = ".q($W)." COLLATE ".charset($g)."_bin";}foreach((array)$Z["null"]as$w)$L[]=escape_key($w)." IS NULL";return
implode(" AND ",$L);}function
where_check($W,$m=array()){parse_str($W,$Ha);remove_slashes(array(&$Ha));return
where($Ha,$m);}function
where_link($r,$e,$X,$ud="="){return"&where%5B$r%5D%5Bcol%5D=".urlencode($e)."&where%5B$r%5D%5Bop%5D=".urlencode(($X!==null?$ud:"IS NULL"))."&where%5B$r%5D%5Bval%5D=".urlencode($X);}function
convert_fields($f,$m,$O=array()){$L="";foreach($f
as$w=>$W){if($O&&!in_array(idf_escape($w),$O))continue;$ra=convert_field($m[$w]);if($ra)$L.=", $ra AS ".idf_escape($w);}return$L;}function
cookie($D,$X,$Vc=2592000){global$aa;return
header("Set-Cookie: $D=".urlencode($X).($Vc?"; expires=".gmdate("D, d M Y H:i:s",time()+$Vc)." GMT":"")."; path=".preg_replace('~\?.*~','',$_SERVER["REQUEST_URI"]).($aa?"; secure":"")."; HttpOnly; SameSite=lax",false);}function
restart_session(){if(!ini_bool("session.use_cookies"))session_start();}function
stop_session($ac=false){$nf=ini_bool("session.use_cookies");if(!$nf||$ac){session_write_close();if($nf&&@ini_set("session.use_cookies",false)===false)session_start();}}function&get_session($w){return$_SESSION[$w][DRIVER][SERVER][$_GET["username"]];}function
set_session($w,$W){$_SESSION[$w][DRIVER][SERVER][$_GET["username"]]=$W;}function
auth_url($Y,$P,$U,$i=null){global$wb;preg_match('~([^?]*)\??(.*)~',remove_from_uri(implode("|",array_keys($wb))."|username|".($i!==null?"db|":"").session_name()),$_);return"$_[1]?".(sid()?SID."&":"").($Y!="server"||$P!=""?urlencode($Y)."=".urlencode($P)."&":"")."username=".urlencode($U).($i!=""?"&db=".urlencode($i):"").($_[2]?"&$_[2]":"");}function
is_ajax(){return($_SERVER["HTTP_X_REQUESTED_WITH"]=="XMLHttpRequest");}function
redirect($z,$B=null){if($B!==null){restart_session();$_SESSION["messages"][preg_replace('~^[^?]*~','',($z!==null?$z:$_SERVER["REQUEST_URI"]))][]=$B;}if($z!==null){if($z=="")$z=".";header("Location: $z");exit;}}function
query_redirect($J,$z,$B,$Xd=true,$Nb=true,$Rb=false,$Oe=""){global$g,$k,$b;if($Nb){$ze=microtime(true);$Rb=!$g->query($J);$Oe=format_time($ze);}$ye="";if($J)$ye=$b->messageQuery($J,$Oe,$Rb);if($Rb){$k=error().$ye.script("messagesPrint();");return
false;}if($Xd)redirect($z,$B.$ye);return
true;}function
queries($J){global$g;static$Sd=array();static$ze;if(!$ze)$ze=microtime(true);if($J===null)return
array(implode("\n",$Sd),format_time($ze));$Sd[]=(preg_match('~;$~',$J)?"DELIMITER ;;\n$J;\nDELIMITER ":$J).";";return$g->query($J);}function
apply_queries($J,$Ie,$Kb='table'){foreach($Ie
as$S){if(!queries("$J ".$Kb($S)))return
false;}return
true;}function
queries_redirect($z,$B,$Xd){list($Sd,$Oe)=queries(null);return
query_redirect($Sd,$z,$B,$Xd,false,!$Xd,$Oe);}function
format_time($ze){return
sprintf('%.3f s',max(0,microtime(true)-$ze));}function
relative_uri(){return
str_replace(":","%3a",preg_replace('~^[^?]*/([^?]*)~','\1',$_SERVER["REQUEST_URI"]));}function
remove_from_uri($Cd=""){return
substr(preg_replace("~(?<=[?&])($Cd".(SID?"":"|".session_name()).")=[^&]*&~",'',relative_uri()."&"),0,-1);}function
pagination($H,$fb){return" ".($H==$fb?$H+1:'<a href="'.h(remove_from_uri("page").($H?"&page=$H".($_GET["next"]?"&next=".urlencode($_GET["next"]):""):"")).'">'.($H+1)."</a>");}function
get_file($w,$lb=false){$Ub=$_FILES[$w];if(!$Ub)return
null;foreach($Ub
as$w=>$W)$Ub[$w]=(array)$W;$L='';foreach($Ub["error"]as$w=>$k){if($k)return$k;$D=$Ub["name"][$w];$Ue=$Ub["tmp_name"][$w];$Xa=file_get_contents($lb&&preg_match('~\.gz$~',$D)?"compress.zlib://$Ue":$Ue);if($lb){$ze=substr($Xa,0,3);if(function_exists("iconv")&&preg_match("~^\xFE\xFF|^\xFF\xFE~",$ze,$Yd))$Xa=iconv("utf-16","utf-8",$Xa);elseif($ze=="\xEF\xBB\xBF")$Xa=substr($Xa,3);$L.=$Xa."\n\n";}else$L.=$Xa;}return$L;}function
upload_error($k){$dd=($k==UPLOAD_ERR_INI_SIZE?ini_get("upload_max_filesize"):0);return($k?'Súbor sa nepodarilo nahrať.'.($dd?" ".sprintf('Maximálna povolená veľkosť súboru je %sB.',$dd):""):'Súbor neexistuje.');}function
repeat_pattern($Gd,$Tc){return
str_repeat("$Gd{0,65535}",$Tc/65535)."$Gd{0,".($Tc%65535)."}";}function
is_utf8($W){return(preg_match('~~u',$W)&&!preg_match('~[\0-\x8\xB\xC\xE-\x1F]~',$W));}function
shorten_utf8($R,$Tc=80,$De=""){if(!preg_match("(^(".repeat_pattern("[\t\r\n -\x{10FFFF}]",$Tc).")($)?)u",$R,$_))preg_match("(^(".repeat_pattern("[\t\r\n -~]",$Tc).")($)?)",$R,$_);return
h($_[1]).$De.(isset($_[2])?"":"<i>…</i>");}function
format_number($W){return
strtr(number_format($W,0,".",' '),preg_split('~~u','0123456789',-1,PREG_SPLIT_NO_EMPTY));}function
friendly_url($W){return
preg_replace('~[^a-z0-9_]~i','-',$W);}function
hidden_fields($Qd,$_c=array(),$Md=''){$L=false;foreach($Qd
as$w=>$W){if(!in_array($w,$_c)){if(is_array($W))hidden_fields($W,array(),$w);else{$L=true;echo'<input type="hidden" name="'.h($Md?$Md."[$w]":$w).'" value="'.h($W).'">';}}}return$L;}function
hidden_fields_get(){echo(sid()?'<input type="hidden" name="'.session_name().'" value="'.h(session_id()).'">':''),(SERVER!==null?'<input type="hidden" name="'.DRIVER.'" value="'.h(SERVER).'">':""),'<input type="hidden" name="username" value="'.h($_GET["username"]).'">';}function
table_status1($S,$Sb=false){$L=table_status($S,$Sb);return($L?$L:array("Name"=>$S));}function
column_foreign_keys($S){global$b;$L=array();foreach($b->foreignKeys($S)as$ec){foreach($ec["source"]as$W)$L[$W][]=$ec;}return$L;}function
enum_input($bf,$c,$l,$X,$Eb=null){global$b;preg_match_all("~'((?:[^']|'')*)'~",$l["length"],$A);$L=($Eb!==null?"<label><input type='$bf'$c value='$Eb'".((is_array($X)?in_array($Eb,$X):$X===0)?" checked":"")."><i>".'prázdne'."</i></label>":"");foreach($A[1]as$r=>$W){$W=stripcslashes(str_replace("''","'",$W));$Ia=(is_int($X)?$X==$r+1:(is_array($X)?in_array($r+1,$X):$X===$W));$L.=" <label><input type='$bf'$c value='".($r+1)."'".($Ia?' checked':'').'>'.h($b->editVal($W,$l)).'</label>';}return$L;}function
input($l,$X,$p){global$cf,$b,$v;$D=h(bracket_escape($l["field"]));echo"<td class='function'>";if(is_array($X)&&!$p){$qa=array($X);if(version_compare(PHP_VERSION,5.4)>=0)$qa[]=JSON_PRETTY_PRINT;$X=call_user_func_array('json_encode',$qa);$p="json";}$be=($v=="mssql"&&$l["auto_increment"]);if($be&&!$_POST["save"])$p=null;$jc=(isset($_GET["select"])||$be?array("orig"=>'originál'):array())+$b->editFunctions($l);$c=" name='fields[$D]'";if($l["type"]=="enum")echo
h($jc[""])."<td>".$b->editInput($_GET["edit"],$l,$c,$X);else{$pc=(in_array($p,$jc)||isset($jc[$p]));echo(count($jc)>1?"<select name='function[$D]'>".optionlist($jc,$p===null||$pc?$p:"")."</select>".on_help("getTarget(event).value.replace(/^SQL\$/, '')",1).script("qsl('select').onchange = functionChange;",""):h(reset($jc))).'<td>';$Dc=$b->editInput($_GET["edit"],$l,$c,$X);if($Dc!="")echo$Dc;elseif(preg_match('~bool~',$l["type"]))echo"<input type='hidden'$c value='0'>"."<input type='checkbox'".(preg_match('~^(1|t|true|y|yes|on)$~i',$X)?" checked='checked'":"")."$c value='1'>";elseif($l["type"]=="set"){preg_match_all("~'((?:[^']|'')*)'~",$l["length"],$A);foreach($A[1]as$r=>$W){$W=stripcslashes(str_replace("''","'",$W));$Ia=(is_int($X)?($X>>$r)&1:in_array($W,explode(",",$X),true));echo" <label><input type='checkbox' name='fields[$D][$r]' value='".(1<<$r)."'".($Ia?' checked':'').">".h($b->editVal($W,$l)).'</label>';}}elseif(preg_match('~blob|bytea|raw|file~',$l["type"])&&ini_bool("file_uploads"))echo"<input type='file' name='fields-$D'>";elseif(($Le=preg_match('~text|lob|memo~i',$l["type"]))||preg_match("~\n~",$X)){if($Le&&$v!="sqlite")$c.=" cols='50' rows='12'";else{$N=min(12,substr_count($X,"\n")+1);$c.=" cols='30' rows='$N'".($N==1?" style='height: 1.2em;'":"");}echo"<textarea$c>".h($X).'</textarea>';}elseif($p=="json"||preg_match('~^jsonb?$~',$l["type"]))echo"<textarea$c cols='50' rows='12' class='jush-js'>".h($X).'</textarea>';else{$fd=(!preg_match('~int~',$l["type"])&&preg_match('~^(\d+)(,(\d+))?$~',$l["length"],$_)?((preg_match("~binary~",$l["type"])?2:1)*$_[1]+($_[3]?1:0)+($_[2]&&!$l["unsigned"]?1:0)):($cf[$l["type"]]?$cf[$l["type"]]+($l["unsigned"]?0:1):0));if($v=='sql'&&min_version(5.6)&&preg_match('~time~',$l["type"]))$fd+=7;echo"<input".((!$pc||$p==="")&&preg_match('~(?<!o)int(?!er)~',$l["type"])&&!preg_match('~\[\]~',$l["full_type"])?" type='number'":"")." value='".h($X)."'".($fd?" data-maxlength='$fd'":"").(preg_match('~char|binary~',$l["type"])&&$fd>20?" size='40'":"")."$c>";}echo$b->editHint($_GET["edit"],$l,$X);$Xb=0;foreach($jc
as$w=>$W){if($w===""||!$W)break;$Xb++;}if($Xb)echo
script("mixin(qsl('td'), {onchange: partial(skipOriginal, $Xb), oninput: function () { this.onchange(); }});");}}function
process_input($l){global$b,$j;$yc=bracket_escape($l["field"]);$p=$_POST["function"][$yc]??null;$X=$_POST["fields"][$yc];if($l["type"]=="enum"){if($X==-1)return
false;if($X=="")return"NULL";return+$X;}if($l["auto_increment"]&&$X=="")return
null;if($p=="orig")return(preg_match('~^CURRENT_TIMESTAMP~i',$l["on_update"])?idf_escape($l["field"]):false);if($p=="NULL")return"NULL";if($l["type"]=="set")return
array_sum((array)$X);if($p=="json"){$p="";$X=json_decode($X,true);if(!is_array($X))return
false;return$X;}if(preg_match('~blob|bytea|raw|file~',$l["type"])&&ini_bool("file_uploads")){$Ub=get_file("fields-$yc");if(!is_string($Ub))return
false;return$j->quoteBinary($Ub);}return$b->processInput($l,$X,$p);}function
fields_from_edit(){global$j;$L=array();foreach((array)$_POST["field_keys"]as$w=>$W){if($W!=""){$W=bracket_escape($W);$_POST["function"][$W]=$_POST["field_funs"][$w];$_POST["fields"][$W]=$_POST["field_vals"][$w];}}foreach((array)$_POST["fields"]as$w=>$W){$D=bracket_escape($w,1);$L[$D]=array("field"=>$D,"privileges"=>array("insert"=>1,"update"=>1),"null"=>1,"auto_increment"=>($w==$j->primary),);}return$L;}function
search_tables(){global$b,$g;$_GET["where"][0]["val"]=$_POST["query"];$ne="<ul>\n";foreach(table_status('',true)as$S=>$T){$D=$b->tableName($T);if(isset($T["Engine"])&&$D!=""&&(!$_POST["tables"]||in_array($S,$_POST["tables"]))){$K=$g->query("SELECT".limit("1 FROM ".table($S)," WHERE ".implode(" AND ",$b->selectSearchProcess(fields($S),array())),1));if(!$K||$K->fetch_row()){$Od="<a href='".h(ME."select=".urlencode($S)."&where[0][op]=".urlencode($_GET["where"][0]["op"])."&where[0][val]=".urlencode($_GET["where"][0]["val"]))."'>$D</a>";echo"$ne<li>".($K?$Od:"<p class='error'>$Od: ".error())."\n";$ne="";}}}echo($ne?"<p class='message'>".'Žiadne tabuľky.':"</ul>")."\n";}function
dump_headers($xc,$id=false){global$b;$L=$b->dumpHeaders($xc,$id);$_d=$_POST["output"];if($_d!="text")header("Content-Disposition: attachment; filename=".$b->dumpFilename($xc).".$L".($_d!="file"&&preg_match('~^[0-9a-z]+$~',$_d)?".$_d":""));session_write_close();ob_flush();flush();return$L;}function
dump_csv($M){foreach($M
as$w=>$W){if(preg_match('~["\n,;\t]|^0|\.\d*0$~',$W)||$W==="")$M[$w]='"'.str_replace('"','""',$W).'"';}echo
implode(($_POST["format"]=="csv"?",":($_POST["format"]=="tsv"?"\t":";")),$M)."\r\n";}function
apply_sql_function($p,$e){return($p?($p=="unixepoch"?"DATETIME($e, '$p')":($p=="count distinct"?"COUNT(DISTINCT ":strtoupper("$p("))."$e)"):$e);}function
get_temp_dir(){$L=ini_get("upload_tmp_dir");if(!$L){if(function_exists('sys_get_temp_dir'))$L=sys_get_temp_dir();else{$n=@tempnam("","");if(!$n)return
false;$L=dirname($n);unlink($n);}}return$L;}function
file_open_lock($n){$o=@fopen($n,"r+");if(!$o){$o=@fopen($n,"w");if(!$o)return;chmod($n,0660);}flock($o,LOCK_EX);return$o;}function
file_write_unlock($o,$gb){rewind($o);fwrite($o,$gb);ftruncate($o,strlen($gb));flock($o,LOCK_UN);fclose($o);}function
password_file($bb){$n=get_temp_dir()."/adminer.key";$L=@file_get_contents($n);if($L||!$bb)return$L;$o=@fopen($n,"w");if($o){chmod($n,0660);$L=rand_string();fwrite($o,$L);fclose($o);}return$L;}function
rand_string(){return
md5(uniqid(mt_rand(),true));}function
select_value($W,$y,$l,$Me){global$b;if(is_array($W)){$L="";foreach($W
as$Kc=>$V)$L.="<tr>".($W!=array_values($W)?"<th>".h($Kc):"")."<td>".select_value($V,$y,$l,$Me);return"<table cellspacing='0'>$L</table>";}if(!$y)$y=$b->selectLink($W,$l);if($y===null){if(is_mail($W))$y="mailto:$W";if(is_url($W))$y=$W;}$L=$b->editVal($W,$l);if($L!==null){if(!is_utf8($L))$L="\0";elseif($Me!=""&&is_shortable($l))$L=shorten_utf8($L,max(0,+$Me));else$L=h($L);}return$b->selectVal($L,$y,$l,$W);}function
is_mail($Bb){$sa='[-a-z0-9!#$%&\'*+/=?^_`{|}~]';$vb='[[:alnum:]](?:[-[:alnum:]]{0,61}[[:alnum:]])';$Gd="$sa+(?:\\.$sa+)*@(?:$vb?\\.)+$vb";return
is_string($Bb)&&preg_match("(^$Gd(?:,\\s*$Gd)*\$)i",$Bb);}function
is_url($R){return(bool)preg_match('~^
			https?://                 # scheme
			(?:
				# IPv6 in square brackets
				\[(?:
					(?:[[:xdigit:]]{1,4}:){7}[[:xdigit:]]{1,4} |             # 1:2:3:4:5:6:7:8
					(?:[[:xdigit:]]{1,4}:){1,7}: |                           # 1::                             1:2:3:4:5:6:7::
					(?:[[:xdigit:]]{1,4}:){1,6}:[[:xdigit:]]{1,4} |          # 1::8            1:2:3:4:5:6::8  1:2:3:4:5:6::8
					(?:[[:xdigit:]]{1,4}:){1,5}(?::[[:xdigit:]]{1,4}){1,2} | # 1::7:8          1:2:3:4:5::7:8  1:2:3:4:5::8
					(?:[[:xdigit:]]{1,4}:){1,4}(?::[[:xdigit:]]{1,4}){1,3} | # 1::6:7:8        1:2:3:4::6:7:8  1:2:3:4::8
					(?:[[:xdigit:]]{1,4}:){1,3}(?::[[:xdigit:]]{1,4}){1,4} | # 1::5:6:7:8      1:2:3::5:6:7:8  1:2:3::8
					(?:[[:xdigit:]]{1,4}:){1,2}(?::[[:xdigit:]]{1,4}){1,5} | # 1::4:5:6:7:8    1:2::4:5:6:7:8  1:2::8
					[[:xdigit:]]{1,4}:(?::[[:xdigit:]]{1,4}){1,6} |          # 1::3:4:5:6:7:8  1::3:4:5:6:7:8  1::8
					:(?::[[:xdigit:]]{1,4}){1,7} |                           # ::2:3:4:5:6:7:8 ::2:3:4:5:6:7:8 ::8
					fe80:(?::[[:xdigit:]]{0,4}){0,4}%[[:alnum:]]+ |          # fe80::7:8%eth0  fe80::7:8%1     (link-local IPv6 addresses with zone index)
					::(?:ffff(?::0{1,4})?:)?
						(?:(?:25[0-5]|(?:2[0-4]|1?[0-9])?[0-9])\.){3}
						(?:25[0-5]|(?:2[0-4]|1?[0-9])?[0-9])
						(?<!\b0\.0\.0\.0) |                                  # ::255.255.255.255  ::ffff:255.255.255.255 ::ffff:0:255.255.255.255  (IPv4-mapped IPv6 addresses and IPv4-translated addresses)
					(?:[[:xdigit:]]{1,4}:){1,4}:
						(?:(?:25[0-5]|(?:2[0-4]|1?[0-9])?[0-9])\.){3}
						(?:25[0-5]|(?:2[0-4]|1?[0-9])?[0-9])
						(?<!\b0\.0\.0\.0)                                    # 2001:db8:3:4::192.0.2.33  64:ff9b::192.0.2.33 (IPv4-Embedded IPv6 Address)
				)\] |
				# IPv4
				(?:(?:25[0-5]|(?:2[0-4]|1?[0-9])?[0-9])\.){3}
					(?:25[0-5]|(?:2[0-4]|1?[0-9])?[0-9])
					(?<!\b0\.0\.0\.0) |                                      # 0.0.0.0 excluded for URLs
				# domain
				[_[:alnum:]](?:[-_[:alnum:]]{0,61}[_[:alnum:]])?
					(?:\.[_[:alnum:]](?:[-_[:alnum:]]{0,61}[_[:alnum:]])?)*
			)                         # host
			(?::(?:[1-9]\d{0,3})?\d)? # port
			(?:/[^\s?\#]*)?           # path
			(?:\?[^\s\#]*)?           # query
			(?:\#\S*)?                # fragment
			$~xi',$R);}function
is_shortable($l){return
preg_match('~char|text|json|lob|geometry|point|linestring|polygon|string|bytea~',$l["type"]??null);}function
count_rows($S,$Z,$Hc,$q){global$v;$J=" FROM ".table($S).($Z?" WHERE ".implode(" AND ",$Z):"");return($Hc&&($v=="sql"||count($q)==1)?"SELECT COUNT(DISTINCT ".implode(", ",$q).")$J":"SELECT COUNT(*)".($Hc?" FROM (SELECT 1$J GROUP BY ".implode(", ",$q).") x":$J));}function
slow_query($J){global$b,$We,$j;$i=$b->database();$Pe=$b->queryTimeout();$ve=$j->slowQuery($J,$Pe);if(!$ve&&support("kill")&&is_object($h=connect())&&($i==""||$h->select_db($i))){$Mc=$h->result(connection_id());echo'<script',nonce(),'>
var timeout = setTimeout(function () {
	ajax(\'',js_escape(ME),'script=kill\', function () {
	}, \'kill=',$Mc,'&token=',$We,'\');
}, ',1000*$Pe,');
</script>
';}else$h=null;ob_flush();flush();$L=@get_key_vals(($ve?$ve:$J),$h,false);if($h){echo
script("clearTimeout(timeout);");ob_flush();flush();}return$L;}function
get_token(){$Vd=rand(1,1e6);return($Vd^$_SESSION["token"]).":$Vd";}function
verify_token(){list($We,$Vd)=explode(":",$_POST["token"]);return($Vd^$_SESSION["token"])==$We;}function
lzw_decompress($Ba){$tb=256;$Ca=8;$Ma=array();$de=0;$ee=0;for($r=0;$r<strlen($Ba);$r++){$de=($de<<8)+ord($Ba[$r]);$ee+=8;if($ee>=$Ca){$ee-=$Ca;$Ma[]=$de>>$ee;$de&=(1<<$ee)-1;$tb++;if($tb>>$Ca)$Ca++;}}$sb=range("\0","\xFF");$L="";foreach($Ma
as$r=>$La){$Ab=$sb[$La];if(!isset($Ab))$Ab=$_f.$_f[0];$L.=$Ab;if($r)$sb[]=$_f.$Ab[0];$_f=$Ab;}return$L;}function
on_help($Sa,$te=0){return
script("mixin(qsl('select, input'), {onmouseover: function (event) { helpMouseover.call(this, event, $Sa, $te) }, onmouseout: helpMouseout});","");}function
edit_form($S,$m,$M,$kf){global$b,$v,$We,$k;$He=$b->tableName(table_status1($S,true));page_header(($kf?'Upraviť':'Vložiť'),$k,array("select"=>array($S,$He)),$He);$b->editRowPrint($S,$m,$M,$kf);if($M===false)echo"<p class='error'>".'Žiadne riadky.'."\n";echo'<form action="" method="post" enctype="multipart/form-data" id="form">
';if(!$m)echo"<p class='error'>".'Nemáte oprávnenie na aktualizáciu tejto tabuľky.'."\n";else{echo"<table cellspacing='0' class='layout'>".script("qsl('table').onkeydown = editingKeydown;");foreach($m
as$D=>$l){echo"<tr><th>".$b->fieldName($l);$mb=$_GET["set"][bracket_escape($D)]??null;if($mb===null){$mb=$l["default"];if($l["type"]=="bit"&&preg_match("~^b'([01]*)'\$~",$mb,$Yd))$mb=$Yd[1];}$X=($M!==null?($M[$D]!=""&&$v=="sql"&&preg_match("~enum|set~",$l["type"])?(is_array($M[$D])?array_sum($M[$D]):+$M[$D]):(is_bool($M[$D])?+$M[$D]:$M[$D])):(!$kf&&$l["auto_increment"]?"":(isset($_GET["select"])?false:$mb)));if(!$_POST["save"]&&is_string($X))$X=$b->editVal($X,$l);$Zb=null;if(isset($_POST["function"][$D]))$Zb=(string)$_POST["function"][$D];$p=($_POST["save"]?$Zb:($kf&&preg_match('~^CURRENT_TIMESTAMP~i',$l["on_update"])?"now":($X===false?null:($X!==null?'':'NULL'))));if(!$_POST&&!$kf&&$X==$l["default"]&&preg_match('~^[\w.]+\(~',$X))$p="SQL";if(preg_match("~time~",$l["type"])&&preg_match('~^CURRENT_TIMESTAMP~i',$X)){$X="";$p="now";}input($l,$X,$p);echo"\n";}if(!support("table"))echo"<tr>"."<th><input name='field_keys[]'>".script("qsl('input').oninput = fieldChange;")."<td class='function'>".html_select("field_funs[]",$b->editFunctions(array("null"=>isset($_GET["select"]))))."<td><input name='field_vals[]'>"."\n";echo"</table>\n";}echo"<p>\n";if($m){echo"<input type='submit' value='".'Uložiť'."'>\n";if(!isset($_GET["select"])){echo"<input type='submit' name='insert' value='".($kf?'Uložiť a pokračovať v úpravách':'Uložiť a vložiť ďalší')."' title='Ctrl+Shift+Enter'>\n",($kf?script("qsl('input').onclick = function () { return !ajaxForm(this.form, '".'Ukladá sa'."…', this); };"):"");}}echo($kf?"<input type='submit' name='delete' value='".'Zmazať'."'>".confirm()."\n":($_POST||!$m?"":script("focus(qsa('td', qs('#form'))[1].firstChild);")));if(isset($_GET["select"]))hidden_fields(array("check"=>(array)$_POST["check"],"clone"=>$_POST["clone"],"all"=>$_POST["all"]));echo'<input type="hidden" name="referer" value="',h(isset($_POST["referer"])?$_POST["referer"]:$_SERVER["HTTP_REFERER"]),'">
<input type="hidden" name="save" value="1">
<input type="hidden" name="token" value="',$We,'">
</form>
';}if(isset($_GET["file"])){if($_SERVER["HTTP_IF_MODIFIED_SINCE"]){header("HTTP/1.1 304 Not Modified");exit;}header("Expires: ".gmdate("D, d M Y H:i:s",time()+365*24*60*60)." GMT");header("Last-Modified: ".gmdate("D, d M Y H:i:s")." GMT");header("Cache-Control: immutable");if($_GET["file"]=="favicon.ico"){header("Content-Type: image/x-icon");echo
lzw_decompress("\0\0\0` \0X\0Z\0\0C> \r9\09\$M'JeRd]/LfS9m7I[m|:(nNiTe6+y<^e(,EY\$L\$uDK}>o[`*qJs5ͅmrY<+w|9˷M2}_땢\\\"V\n+MtBK*3ypl5I`V)OWs{OIAs۹㉥N&cO}~hH@GzJyGCcNJЪ`귊FC{вU@i>YJEiNR(9A%!CQ^yat:&۝YGH/\ngxs~@%y8ZUEOac@:\n;G>9i}@p,6&c Fő^%aRAQhIZԵ9z\\š`V5ZjoT9!^O)12l.I~^Qt꒦usI;OlB\$Q9q	\\eTsęUq2H֥J'(EvT!ѐ%EQFPv\\o'JtGIID\"e3-	oj&8E@uTICTUPy3ڶ>L^jbK#qD8ʒ\\Mdql\\y^]94hNk_g^GQ1)PQ8eMUsոbRha&]O5VUз-d23\\U@kWg+˷'gZٖE)KJ|qP=ҟO`[%wOgNMPcS	C!pdS#!KL=}ߠtp4!/k6uNdU28XDXHDvOb4IN<+q*?7WM!X,dXN(Ж=0Kvǘ25F #\$a&LSd\r(ЗFHИᖒ߱2:'M>RXcq)xdCp\rah'\0hDȠ`l&&B8Bm.rAeIQ2@). n`|ًF<䤳ZJ[a(KoP\"4D?TRgLJU_#8%u\$ASʆKJA8f17M]J&1=afK<w\$	MITTH&30?6ls\$DU\$ThI[5*MdbDPLsF\0'AJp-\rG3_k]|m%`_,8sE<2r!;|*TTQ-tق`<GlJi9GLKaK{\n=M+1h/:W\\[q\\Kaleݲu)v-~5UL?ED[1\\V66gĽfΪ8Io]h[ݒ R)!Ι˕W[5K'?};ii]3lFccL|^5;*ǸQ博&<Yu/rٗ\n-x8'\r1)#n9Vx%YdI\ntI*ȳs~m7.ǌRjX+^PeRײ:Je9{#';죥u2Rj]MFZVj]ZZk]mƲ");}elseif($_GET["file"]=="default.css"){header("Content-Type: text/css; charset=utf-8");echo
lzw_decompress("\nCo6C(\"#Ha1#yd1٘n:#(b.\rDc)a7Elñi1Ύs54f4ngsIhMдi:`,]YtL0hD*B0\rF&3xs'[Ʉtv4S%0XLW5)Yf\r^=~9g0\\@rQNn^yNj{opC%ʋGSZh5Z|>:'b{J)Ɠєt1*uS=^2*8t(0R,8j:x@9\n@1\nJ#4BRJFƋ>#J`HaahbC0\r4Ar&\nB54\$>+QA2DoMEL\"48=s5DLW7JGf**HjEK16ڸ,oLtJA\\\$Q|9-H@0\nxtV(o.+ܮ;1D8e*c\rT䍣B2܍z\n83=Ktƻu(kmׅ.G;+:2)cn<s5:6\nԡ)_\\6YL\"VV`c\$L;k&\$?XAWU48	Bޡڮz*[O24<?{36%;VV:\\A䎈	xnpxF<[xoW.U[Ãsd7rF&	bÒ]t*7ji=dZֹYy4:ie&Pg\\1C0:;;ٹ5Cnà\\܎#ܳ4{^g7u6NJ6OC#{!?fxw!70JJL48dpLàypC[.AltPQ'zl=N7@m\n/cTc]tהxiaD+pPpxׅUJ%Da`@^OEc)Ň@@A')hUb!AƸڠT~P\\*9Gi};`ˠh\r1Zlx9HI)AjRWI9!#̆[ysZb--q؇h7➀LjQʻ\"#lU`ׄ^Ar\rffV.QsnhGgN@e%?\$ᰂI;T\0`]B\r8[r2`\rҢ\rCKeF2ٺ\r'[t(),M)ڸ Se=*N@+9%Pin:܋T}ԎMC\rNtg%VÕ]V6Hʒl?Մ_Vhee,3ھF n%^kaM)_a-NB-v)rJ1NUly\0#YM˵Y`EM֭\"UH-_ #ܹE\"\rv42FL8wZ0]5Sw.!0ʴQ͏3E|%}AC0tLk3Pj/kbN`QQ7x_僧B<A8@%>\nx[&\rfy !SLsVG(¹	B\$a[F\\A8G&r;or>biRZMm,d\"<;\"Q?1uV~G,\0գ0c`IϣEPR^fBhUuɔ3CH(& i:\rt.W&5}UmߗpQNi`\ndi#(1QKҒ\nI,Yf`'(p7`q\rt\0U\rsr:ħ0و;A,v0p\rBPcrR^m.o\n=\\9%F7ZV#0|Yygf?/\"aMܿHnЬDdjl\0nAxsP(3}d#u`'p@[[T*`Z?\\!>˄vl}zf3; !(6/&A\08\0\0r\rp4{TT/!\ruAtH8JU`r9`j\r-H\"ՃATH ? }qA3l~a~2I^`Z\0004 ̓eP&\0p`n8pd%f\0sO`hD0\0p, i\$\\\0mO[ nD&`aP\\p2.0/0P0\nbVDd&&jd\"ioB0\$&\0aGJ& @&O7@i\$%\n0/bdo.\rro<\rP^Q\n	o`/\r^P}O6@nD d@0	^s\0#\0\$zIQjoc0M0OC [0@Q@`pf/P,ANp|PNF:ol@pPo@I`c	\$p/%\0HњpuP!h+\"A\$\"a_'/?U6DّCq fdiP\n%uQ\0e@pp#q\0\$o\npDB\0ϓ\00^P\"oB0ZO1	a*%Vj҄?/-!B,W\"ϑP\nPEFk/p_\rc+/\$S/7+/4_Lq'`D2%ύų#\r nב7p1#p7`O0\$o-!2Pѽ'&02	Nv/1\$io5\nO ip<23QD1</1-W\rCҍSٓ\n	\0\r؄JdrP#(J^nA N4\$(?\"CtH\r*\"1eptox\r|9ӰA \rADtKB@\0OCorsG`/kԍE,@O(KF,R+0A!/P\0%#s}PP;\rETE6\r@*hUK01uI8@^:`pR\0' T@b\"UaUdhi1SR+K	OtmJGTGE\0qq\n/jQ\0RA3s.Na\\@\n*1/\"a[/ϛ0Nك<aR0QUa/-P\\Hoap-%/\nskUѼ	\\#]6M!Tfr^\r*%PIZoKQ\"VE952S\$i+6OHѶZO'Zp2U M0<,Y1[Ui96-PR8p\r3?7O'cҳ`r;ӝ``%31A4%WhYqoG7oa,[Q7o sk_gii,rOij1CqI\0/!ғ]^TPHwM!wmQ01+mR},O?+T5pNK^Sfhssvk71f/5cg\0n@1zҴ\0koPI#\0i'E{GZ\rVxR`0#!/\nqc!1g?2nOj@pД@j\r<9Oq~@e0!3P#?YqلҸ5/?\0/6tIus cDi7nW\$UmA3kR?u\0r}Wt_bctō23p01r;bVv6;%17/)(]1W'QU1 v0\0gtADAWBtWX\"aXu9I<5CCTEEKATE4!W6) RccR\$kcL3:#T4'sOcV/\03\"T4j)PP%r;oLՏJT\$rnt6Ne95+#a2\r'MPo9UUmQX{Y ۛqu\0g&ZO-[IZ::?SA\0ڂ` D\"Bm*ePSj`JX\"ɍKFY>0nz\r:\00043,b,f(hޚLG3ICG.X.,7.j{\$]mrmV.Ξ\0N*vuXH`zON/V^ dɨD\0ƘhI\"˨piERVc9.O-.k\0DϻaE[HL\"b[Cj;EF9Q\"E|[2{M\0D	Fi\0h	\0`[痠E\ns\r0nsidCI@eŶ#eRivŜKn\\-|;7`qH`E܇BɚCӮܢ9||z^'p	c8-	bҕIP!G*@%:@C[	+; \0i(,LC!1[HPV[W`{dK)X\\ik=d.Е{Cכ񛿶<ɿ-I;Խ7\"Q?#ٛ9jE-%ۃ<<-\\)ͣY`\rIN!lHpI8!d]ܽٔ<yẉf	/j‘	gɵ<-DǛ>葱\rN]{юqd2]1tHFi[CcL\$_]Ӯ{kt]Ky՛i{\$Si =of{Ֆ[ݜݠ!]A=4e=#F;׾ĉ¿ܜ+ȓvƜMnsNHqw\\V?E<>	!'=|Rwd6ϊ\rwI?_yɾ!)fw˞3匥w~F#ɅxWt1(ɇRerW!I[ʤp)K1@HfI:Q S	r;5nbkqTʒ;  o*@r&Glq<\0.w6VckBhH(jOC7yC(mpV\n*1#n<[BR92E@&F(\n?J͐[ARWaػv8Wf#P:k{d`a't#tBmCXdr+sP,Adhwb?``b[ʡ\\+HXD90Ö]CY\$/Xk`/\"5|Q`Q\rj\\'CB?Uҏ,F4><agoA,(MNrHkeI,T*}òp8oPi yp\\'?9I&JNه:͏<.c01 3hB*aEzkhLmSԝ8:Ym˩vꗯ{	^^UQI{H[!\"ە^N{x4;!|}|nŵvb9ݎ<9qaY`c8;o\0f1\$o@5`} 7@h +((wq4i6x=ѣq;'9Qd# ſNiyq%>/ãb7ډ\rClFTqTaxˀ/Nt_^e\"6<1SƼ<G_+AWch=xL}GC8{Po,>9[]٘h@PÇ=4H~B\$N&4ѰPD, \0V@rj\$>:D\$	_Z#r;z4'|A HAPI}Dq*J8p\n EQ8\n  \$m`)W0ZI&ji2J²[Q\n~b@xkXrQAzb\$+ 	\"搐D\niC>\nҊ4)T{dQh`{&oBr,B(JjFād!\\jZQAO+2T,@");}elseif($_GET["file"]=="functions.js"){header("Content-Type: text/javascript; charset=utf-8");echo
lzw_decompress("f:gCI\n83)781x:\nOg#)r7\n\"`|2gSiH)NS\r\"0@)`(\$s6O!V/=' T4=iS6IOG#XVCsZ1.hp8,[H~Cz2lc3sIb4\nF8TIU*fzr0EyfY.:I(c΋!_l^^(N{S)rqYl٦33\n+GyixV3wuh^ra۔c\r(.Ch<\r)ѣ`743'm5\nP:2Pq C}ī38B0hRr(0b\\0Hr44B!p\$rZZ2܉.Ƀ(\\5|\nC(\"P.NRTΓ>HN8HP\\7Jp~2%OC1.C8·H*jS(/6KU<2pOI`ⳈdOH5-4pX25-Ңۈz7\"(P\\32:]U߅!]<Aۤiڰl\r\0v#J8wmɤ<ɠ%m;p#`XDiZN09占`v0C98a^M4Ł\r|7zF[\n(7vIĈ2,9Ì#ȨDWR;P'm3샂\n\0u39Cw2fp{и/	o4ax/ \\.=NJG@YE9a߉mg[ӹ=z{4\01CH:>X>~]\0dws!:%9~a\nj0XuS6dIV3̼r`AD@x9'A@\\Ta3((\nP`o{e9=	`\"	[B{!:x?)'|f8C ?Pu|@xR;U\0(.5joN)/97LA#8eACA0&#wKդRGZaH	UݑpRb`WްJ\n!MDxkVnO(#yN#h\"@1\0Ɖ#8L2\\rQ\0r\r`Yvb+1Hl`%z. M 5lNb\$2TxH`XHSWmb)'>'zP!и@?V=8\n+da07;ɹ*~WwܕR*T8CҮ]Xn'I2n\$p4JtX<>yK)qi%Ű4>V\nH{Jj1}6JSPCa2\"}s(ڙ^m*D9ͩɸu:AyT˩L͜:+p^VJGff5%y	ܞY[댝[\$EUYZuJdA6[-CHl)ʃm=GfclRVxU UXR\$ij˻G	2[T'\n5sFYhi\0X%_!\rE44ltm93lS{S*g8\$\"kHO)Jbʵp%\\Ps#)B:ai Z^\nkv2FPJʘnB,ܧfX5pB`ooI!=8)caH㨬b(JGaʏ\"BF T{Rp*e~2^ >v>%^13wCX=!gTe=9p>5;u+hMWZA\rė\\M\\3gМ[YvqX[b)2\rWL+ŊezA|ed9Ae\\ap.@_긳~cp%-ZW[QI7E5uȔ[6%PCio[1A4KD\$i.	?V{/_y]@^q&#\0O</q\"檭\\WUHyWtjV{nVf+μt,Ċ^g:LUiݻe*ǏW/-%嬍\"8C^&(E\\6ZN9ysv^/B0RZO\0;`N &Q;P2Β+=MtZ472hLWoK'& zHܧj?\nRDG*Ӊ-#<I,P,Z;h\0#NM>I`(E4\rT]\"V\0XQj~ bR`MN-RSN,\"0	d~y\r\r@`Q-\\s\n.P)]\0p\r]T*}\rp#-jEmp!ɨf@@W<cmXv	z|KJm\0@WX\0Kl<!N*GECZoBzТ\rxGeHNH(gj񂰯\0xoK@11lD\$Р`Dv V bSгH`2pn.qQJ+*fMp\r /D*\"w\$o2[QF`M|1Rho'&5#%j>jMگt@&rpGdDbtsR\$r!N2qo{*,DɯbrM`.QqD%јG	!J-+EDE`{0䧩0DE#p(7#2ܳbd73M&ysH\"74rL9-f*܋/rRŘRBn*ij@nB茴\\FIX%x f\$9J}9a0qsnFH|@E3};)k7|HKK5SdvR@  ( \r&*Ja@fp+Jk,w _?\"X\rN3'5&t%;A8Lrn?EQ\0%NSka8\0Ю<DUGF8VTDWe7`HtHn GJl;HTjN`@HDs[tΎ((Hexm7vyIҾ#T=>()\$_ԧOOQ-e(*GKdKt`DV!C8sDi<)3BKU;8SZB(.GDc,EuTpdl7J38DK\nbtNSHUt#{VluVZuF\r@`]6Zǌǀ][\\\rf(0SS43D'W:Sc:ǅb)fĢ#w5vs,rw6&\\m0\0ڜ\nJv66Kd)cu&R37NSX5>DUZ:Z'rT7Sk_G[Ĩ\$KU\\x<m5#[E\\ɞ0WJ*.\ro]#C*5kg|<-uSO7TS^hosp f֍8I\\#8_R{pe'2=S@[:e8ҕd35]r֪ֈ&De\$nW[3^vTԖw)vܭX0cmasZ xm׌בPyyz:^2b᎗9Uqo of>\";K|3yVhl	0No.%@OGvJ7M(A,\"[\0/, %Īσ*2x}˦gA!,,ǖ:&\r,3_-ԇlHo8vwSj)V)(NSXHXMXCx'/AXZ^|f҃i,ʸg؎[ڭ@QbLxJ\0jS Z	VB\"Ћc<ТtP5uP\rܬm\"yBCMnw^1 Njx./*ntI\"2\"=r\$:kwba.1>3h(Kom5;2g|B\"iD\rgBX%rV\0n\\FMm\0~\\͞4`.*\0@'9  d	{6瞠\nP놾In˛Y[VXm^oԢ?g<P@N/KsDeP\0xǤg}[sG俥S5u%%E@/OZe{LY))BR`	\nQCLyh783\0˲\06!N\"\$[h@aZZd\"\\\"Vg9[)hN`mL-՟fЍd oXh\"kӸsJ\"m2N2T.uǜyp'c)(ݦ[ɶ[`g;SZJzK&jZOp	ɧ@˪ZJz(Ӯ@{8\0_Ł\n3/|u0K:IV:YņEmRfn4fow1rN2sb0ق<d/eGfZXɌ<I<,b\rǖK\rJ\"H+q-wP,\$߫%U,՘@ӮLiT0K2yiĳ=|\\9wā2B5\n\refJ]ѳWGyb'HQ\\\n@ s#p8P}}j\ro`\rE RMMHJW nt\r*NoCMCB\"_HkRN#]d<.\\Xe&_G_n%9ƛm4\\Veg1'ao\r5p|[\0М@h tPbgӦ|)l{)~|̙קsz1vtFF)XA4y/g!ghNqh_j̏k+`0woSkW~,~P<3h~~DXE	\"ɺkRb\$BI!IYxF%FTg6-X/\"RmdkXQ`FS?V7Uвp&إsx@o|?MW`iHBC9꥚e;3;HP\"L5	#^S,5`#\"NɢB,\$o&n;xZ-]>q1 he:\0\r[\"*bw&6Vr\n>󹑭@SȚ܋>,43Y\r*=|Rڍ09il!SL\$`dN d%252(VBA ]E x*	dF38	{f(^>H&Mf^Mҙ\0]B\r	U*nPt`'?\n|,`:{x=8nHrFƧZpsO\n|	QN,O\\)+\n .)\nhY0,_\\n/\$CۄX\nP(\n`X,͹MpҬ++@ƌ8V5yN@'#dH\0X=	kV 	BAPѝ\r(Ydh~qb	6AR\0Xg|\r`\\8H. NJq2\rԉ2[P CJ	V'K[H@KMtT 	V=!%' \nV@!S~ugDWmɗZR-kbr iƬ=08AdLYRS!\"rxYC\0CF^{xȐŸ\r\"K=;A\0t L\"וEѧX#\nƵ/|<CWt^4v6R\"ted)^f6l.&`G5%RJMIB#9T-D\"FXڍ1~ߪJ.-jb`{hX'QHtzV2G!|K*#Gխ~cH1\n%`d3bYxnIȕ`ǷyILhB\0=l!AzS\rMHb\$E6F~Iȵ^aKOj*a*ϓt0-2\r|2@~NF6Ě('`\"CPE\$ep7R^@&/\$Rz\r\\vL?m\"6-\n`q\$@I!҄C움'	9jKv(6\$?[5ʒ#DC%)7Ŧ܂r5N*A̎2쩘<Bc-IR8^!QV]CFBS/zc&@yI\$35Ոl.HlK1 s\"5\rҶ\$)kQjJ܀E.7v^\" Rn%=\nto8^68@ħɦQ MxK8`0%T3 iqɠ:E\\d2I>p\r8Yi]UEd`ԧ^#2dEb\0cL/Y!OTĸ˦ eh\n`jypxB`ð+@4T؀igo\0^PSRumҏ(gߙܥ;5y̴9,Q4J9q'XݼP#	q8?%4&q.Yͤ:q)v5!!ȅk8ʀ {\$IKخQґٖж't0~KYcH) |+&Z\"@\nB DE{#eHL\"V\"y1 j)9ب6iY>s-hЃϱ\0^md9iz#'EA@)aX Q0:F0⷟CUn[bʳ+iHL9cv-!PF+d(K\"bdƄ@_C %|;Pxu,Y<	QpbєW|b\"c!ZsU?[Jٶ]-'x_90vŗF\nʤXB	q]֗FQJBkb(=XG֐v\"	CT̵H6R4ih!^Q\0{j(BCxki:<8HRp\"!Ҝ#[ԍd`0++;*MѶ]%Y,XEP,Rb8a`=wIڡZQ1 !Fb\"Tt\n*bnYhْ,FZpVE¾T|NC@zբ5q9*^\rʎtqhZc=]!HwNK'ԈNTEUS%8(UEdC\rN\rC&iz9");}elseif($_GET["file"]=="jush.js"){header("Content-Type: text/javascript; charset=utf-8");echo
lzw_decompress('');}else{header("Content-Type: image/gif");switch($_GET["file"]){case"plus.gif":echo'';break;case"cross.gif":echo'';break;case"up.gif":echo'';break;case"down.gif":echo'';break;case"arrow.gif":echo'';break;}}exit;}if($_GET["script"]=="version"){$o=file_open_lock(get_temp_dir()."/adminer.version");if($o)file_write_unlock($o,serialize(array("version"=>$_POST["version"])));exit;}global$b,$g,$j,$wb,$zb,$Gb,$k,$jc,$mc,$aa,$Cc,$v,$ba,$Pc,$rd,$Id,$Ae,$qc,$We,$af,$cf,$jf,$ca;if(!$_SERVER["REQUEST_URI"])$_SERVER["REQUEST_URI"]=$_SERVER["ORIG_PATH_INFO"];if(!strpos($_SERVER["REQUEST_URI"],'?')&&$_SERVER["QUERY_STRING"]!="")$_SERVER["REQUEST_URI"].="?$_SERVER[QUERY_STRING]";if($_SERVER["HTTP_X_FORWARDED_PREFIX"])$_SERVER["REQUEST_URI"]=$_SERVER["HTTP_X_FORWARDED_PREFIX"].$_SERVER["REQUEST_URI"];$aa=($_SERVER["HTTPS"]&&strcasecmp($_SERVER["HTTPS"],"off"))||ini_bool("session.cookie_secure");@ini_set("session.use_trans_sid",false);if(!defined("SID")){session_cache_limiter("");session_name("adminer_sid");$Dd=array(0,preg_replace('~\?.*~','',$_SERVER["REQUEST_URI"]),"",$aa);if(version_compare(PHP_VERSION,'5.2.0')>=0)$Dd[]=true;call_user_func_array('session_set_cookie_params',$Dd);session_start();}remove_slashes(array(&$_GET,&$_POST,&$_COOKIE),$Wb);if(function_exists("get_magic_quotes_runtime")&&get_magic_quotes_runtime())set_magic_quotes_runtime(false);@set_time_limit(0);@ini_set("zend.ze1_compatibility_mode",false);@ini_set("precision",15);function
get_lang(){return'sk';}function
lang($Ze,$pd=null){if(is_array($Ze)){$Kd=($pd==1?0:($pd&&$pd<5?1:2));$Ze=$Ze[$Kd];}$Ze=str_replace("%d","%s",$Ze);$pd=format_number($pd);return
sprintf($Ze,$pd);}if(extension_loaded('pdo')){class
Min_PDO{var$_result,$server_info,$affected_rows,$errno,$error,$pdo;function
__construct(){global$b;$Kd=array_search("SQL",$b->operators);if($Kd!==false)unset($b->operators[$Kd]);}function
dsn($xb,$U,$I,$F=array()){$F[PDO::ATTR_ERRMODE]=PDO::ERRMODE_SILENT;$F[PDO::ATTR_STATEMENT_CLASS]=array('Min_PDOStatement');try{$this->pdo=new
PDO($xb,$U,$I,$F);}catch(Exception$Lb){auth_error(h($Lb->getMessage()));}$this->server_info=@$this->pdo->getAttribute(PDO::ATTR_SERVER_VERSION);}function
quote($R){return$this->pdo->quote($R);}function
query($J,$df=false){$K=$this->pdo->query($J);$this->error="";if(!$K){list(,$this->errno,$this->error)=$this->pdo->errorInfo();if(!$this->error)$this->error='Neznáma chyba.';return
false;}$this->store_result($K);return$K;}function
multi_query($J){return$this->_result=$this->query($J);}function
store_result($K=null){if(!$K){$K=$this->_result;if(!$K)return
false;}if($K->columnCount()){$K->num_rows=$K->rowCount();return$K;}$this->affected_rows=$K->rowCount();return
true;}function
next_result(){if(!$this->_result)return
false;$this->_result->_offset=0;return@$this->_result->nextRowset();}function
result($J,$l=0){$K=$this->query($J);if(!$K)return
false;$M=$K->fetch();return$M[$l];}}class
Min_PDOStatement
extends
PDOStatement{var$_offset=0,$num_rows;function
fetch_assoc(){return$this->fetch(PDO::FETCH_ASSOC);}function
fetch_row(){return$this->fetch(PDO::FETCH_NUM);}function
fetch_field(){$M=(object)$this->getColumnMeta($this->_offset++);$M->orgtable=$M->table;$M->orgname=$M->name;$M->charsetnr=(in_array("blob",(array)$M->flags)?63:0);return$M;}}}$wb=array();function
add_driver($s,$D){global$wb;$wb[$s]=$D;}function
get_driver($s){global$wb;return$wb[$s];}class
Min_SQL{var$_conn;function
__construct($g){$this->_conn=$g;}function
select($S,$O,$Z,$q,$G=array(),$x=1,$H=0,$Od=false){global$b,$v;$Hc=(count($q)<count($O));$J=$b->selectQueryBuild($O,$Z,$q,$G,$x,$H);if(!$J)$J="SELECT".limit(($_GET["page"]!="last"&&$x!=""&&$q&&$Hc&&$v=="sql"?"SQL_CALC_FOUND_ROWS ":"").implode(", ",$O)."\nFROM ".table($S),($Z?"\nWHERE ".implode(" AND ",$Z):"").($q&&$Hc?"\nGROUP BY ".implode(", ",$q):"").($G?"\nORDER BY ".implode(", ",$G):""),($x!=""?+$x:null),($H?$x*$H:0),"\n");$ze=microtime(true);$L=$this->_conn->query($J);if($Od)echo$b->selectQuery($J,$ze,!$L);return$L;}function
delete($S,$Td,$x=0){$J="FROM ".table($S);return
queries("DELETE".($x?limit1($S,$J,$Td):" $J$Td"));}function
update($S,$Q,$Td,$x=0,$oe="\n"){$pf=array();foreach($Q
as$w=>$W)$pf[]="$w = $W";$J=table($S)." SET$oe".implode(",$oe",$pf);return
queries("UPDATE".($x?limit1($S,$J,$Td,$oe):" $J$Td"));}function
insert($S,$Q){return
queries("INSERT INTO ".table($S).($Q?" (".implode(", ",array_keys($Q)).")\nVALUES (".implode(", ",$Q).")":" DEFAULT VALUES"));}function
insertUpdate($S,$N,$Nd){return
false;}function
begin(){return
queries("BEGIN");}function
commit(){return
queries("COMMIT");}function
rollback(){return
queries("ROLLBACK");}function
slowQuery($J,$Pe){}function
convertSearch($yc,$W,$l){return$yc;}function
value($W,$l){return(method_exists($this->_conn,'value')?$this->_conn->value($W,$l):(is_resource($W)?stream_get_contents($W):$W));}function
quoteBinary($he){return
q($he);}function
warnings(){return'';}function
tableHelp($D){}}$wb["mongo"]="MongoDB (alpha)";define("DRIVER","mongo");if(class_exists('MongoDB')){class
Min_DB{var$extension="Mongo",$server_info=MongoClient::VERSION,$error,$last_id,$_link,$_db;function
connect($lf,$F){try{$this->_link=new
MongoClient($lf,$F);if($F["password"]!=""){$F["password"]="";try{new
MongoClient($lf,$F);$this->error='Databáza nepodporuje heslo.';}catch(Exception$yb){}}}catch(Exception$yb){$this->error=$yb->getMessage();}}function
query($J){return
false;}function
select_db($hb){try{$this->_db=$this->_link->selectDB($hb);return
true;}catch(Exception$Lb){$this->error=$Lb->getMessage();return
false;}}function
quote($R){return$R;}}class
Min_Result{var$num_rows,$_rows=array(),$_offset=0,$_charset=array();function
__construct($K){foreach($K
as$Jc){$M=array();foreach($Jc
as$w=>$W){if(is_a($W,'MongoBinData'))$this->_charset[$w]=63;$M[$w]=(is_a($W,'MongoId')?"ObjectId(\"$W\")":(is_a($W,'MongoDate')?gmdate("Y-m-d H:i:s",$W->sec)." GMT":(is_a($W,'MongoBinData')?$W->bin:(is_a($W,'MongoRegex')?"$W":(is_object($W)?get_class($W):$W)))));}$this->_rows[]=$M;foreach($M
as$w=>$W){if(!isset($this->_rows[0][$w]))$this->_rows[0][$w]=null;}}$this->num_rows=count($this->_rows);}function
fetch_assoc(){$M=current($this->_rows);if(!$M)return$M;$L=array();foreach($this->_rows[0]as$w=>$W)$L[$w]=$M[$w];next($this->_rows);return$L;}function
fetch_row(){$L=$this->fetch_assoc();if(!$L)return$L;return
array_values($L);}function
fetch_field(){$Lc=array_keys($this->_rows[0]);$D=$Lc[$this->_offset++];return(object)array('name'=>$D,'charsetnr'=>$this->_charset[$D],);}}class
Min_Driver
extends
Min_SQL{public$Nd="_id";function
select($S,$O,$Z,$q,$G=array(),$x=1,$H=0,$Od=false){$O=($O==array("*")?array():array_fill_keys($O,true));$we=array();foreach($G
as$W){$W=preg_replace('~ DESC$~','',$W,1,$Za);$we[$W]=($Za?-1:1);}return
new
Min_Result($this->_conn->_db->selectCollection($S)->find(array(),$O)->sort($we)->limit($x!=""?+$x:0)->skip($H*$x));}function
insert($S,$Q){try{$L=$this->_conn->_db->selectCollection($S)->insert($Q);$this->_conn->errno=$L['code'];$this->_conn->error=$L['err'];$this->_conn->last_id=$Q['_id'];return!$L['err'];}catch(Exception$Lb){$this->_conn->error=$Lb->getMessage();return
false;}}}function
get_databases($Yb){global$g;$L=array();$kb=$g->_link->listDBs();foreach($kb['databases']as$i)$L[]=$i['name'];return$L;}function
count_tables($ib){global$g;$L=array();foreach($ib
as$i)$L[$i]=count($g->_link->selectDB($i)->getCollectionNames(true));return$L;}function
tables_list(){global$g;return
array_fill_keys($g->_db->getCollectionNames(true),'table');}function
drop_databases($ib){global$g;foreach($ib
as$i){$ce=$g->_link->selectDB($i)->drop();if(!$ce['ok'])return
false;}return
true;}function
indexes($S,$h=null){global$g;$L=array();foreach($g->_db->selectCollection($S)->getIndexInfo()as$t){$rb=array();foreach($t["key"]as$e=>$bf)$rb[]=($bf==-1?'1':null);$L[$t["name"]]=array("type"=>($t["name"]=="_id_"?"PRIMARY":($t["unique"]?"UNIQUE":"INDEX")),"columns"=>array_keys($t["key"]),"lengths"=>array(),"descs"=>$rb,);}return$L;}function
fields($S){return
fields_from_edit();}function
found_rows($T,$Z){global$g;return$g->_db->selectCollection($_GET["select"])->count($Z);}$wd=array("=");$vd=null;}elseif(class_exists('MongoDB\Driver\Manager')){class
Min_DB{var$extension="MongoDB",$server_info=MONGODB_VERSION,$affected_rows,$error,$last_id;var$_link;var$_db,$_db_name;function
connect($lf,$F){$d='MongoDB\Driver\Manager';$this->_link=new$d($lf,$F);$this->executeCommand('admin',array('ping'=>1));}function
executeCommand($i,$Sa){$d='MongoDB\Driver\Command';try{return$this->_link->executeCommand($i,new$d($Sa));}catch(Exception$yb){$this->error=$yb->getMessage();return
array();}}function
executeBulkWrite($ld,$Ga,$ab){try{$fe=$this->_link->executeBulkWrite($ld,$Ga);$this->affected_rows=$fe->$ab();return
true;}catch(Exception$yb){$this->error=$yb->getMessage();return
false;}}function
query($J){return
false;}function
select_db($hb){$this->_db_name=$hb;return
true;}function
quote($R){return$R;}}class
Min_Result{var$num_rows,$_rows=array(),$_offset=0,$_charset=array();function
__construct($K){foreach($K
as$Jc){$M=array();foreach($Jc
as$w=>$W){if(is_a($W,'MongoDB\BSON\Binary'))$this->_charset[$w]=63;$M[$w]=(is_a($W,'MongoDB\BSON\ObjectID')?'MongoDB\BSON\ObjectID("'."$W\")":(is_a($W,'MongoDB\BSON\UTCDatetime')?$W->toDateTime()->format('Y-m-d H:i:s'):(is_a($W,'MongoDB\BSON\Binary')?$W->getData():(is_a($W,'MongoDB\BSON\Regex')?"$W":(is_object($W)||is_array($W)?json_encode($W,256):$W)))));}$this->_rows[]=$M;foreach($M
as$w=>$W){if(!isset($this->_rows[0][$w]))$this->_rows[0][$w]=null;}}$this->num_rows=count($this->_rows);}function
fetch_assoc(){$M=current($this->_rows);if(!$M)return$M;$L=array();foreach($this->_rows[0]as$w=>$W)$L[$w]=$M[$w];next($this->_rows);return$L;}function
fetch_row(){$L=$this->fetch_assoc();if(!$L)return$L;return
array_values($L);}function
fetch_field(){$Lc=array_keys($this->_rows[0]);$D=$Lc[$this->_offset++];return(object)array('name'=>$D,'charsetnr'=>$this->_charset[$D],);}}class
Min_Driver
extends
Min_SQL{public$Nd="_id";function
select($S,$O,$Z,$q,$G=array(),$x=1,$H=0,$Od=false){global$g;$O=($O==array("*")?array():array_fill_keys($O,1));if(count($O)&&!isset($O['_id']))$O['_id']=0;$Z=where_to_query($Z);$we=array();foreach($G
as$W){$W=preg_replace('~ DESC$~','',$W,1,$Za);$we[$W]=($Za?-1:1);}if(isset($_GET['limit'])&&is_numeric($_GET['limit'])&&$_GET['limit']>0)$x=$_GET['limit'];$x=min(200,max(1,(int)$x));$ue=$H*$x;$d='MongoDB\Driver\Query';try{return
new
Min_Result($g->_link->executeQuery("$g->_db_name.$S",new$d($Z,array('projection'=>$O,'limit'=>$x,'skip'=>$ue,'sort'=>$we))));}catch(Exception$yb){$g->error=$yb->getMessage();return
false;}}function
update($S,$Q,$Td,$x=0,$oe="\n"){global$g;$i=$g->_db_name;$Z=sql_query_where_parser($Td);$d='MongoDB\Driver\BulkWrite';$Ga=new$d(array());if(isset($Q['_id']))unset($Q['_id']);$Zd=array();foreach($Q
as$w=>$X){if($X=='NULL'){$Zd[$w]=1;unset($Q[$w]);}}$kf=array('$set'=>$Q);if(count($Zd))$kf['$unset']=$Zd;$Ga->update($Z,$kf,array('upsert'=>false));return$g->executeBulkWrite("$i.$S",$Ga,'getModifiedCount');}function
delete($S,$Td,$x=0){global$g;$i=$g->_db_name;$Z=sql_query_where_parser($Td);$d='MongoDB\Driver\BulkWrite';$Ga=new$d(array());$Ga->delete($Z,array('limit'=>$x));return$g->executeBulkWrite("$i.$S",$Ga,'getDeletedCount');}function
insert($S,$Q){global$g;$i=$g->_db_name;$d='MongoDB\Driver\BulkWrite';$Ga=new$d(array());if($Q['_id']=='')unset($Q['_id']);$Ga->insert($Q);return$g->executeBulkWrite("$i.$S",$Ga,'getInsertedCount');}}function
get_databases($Yb){global$g;$L=array();foreach($g->executeCommand('admin',array('listDatabases'=>1))as$kb){foreach($kb->databases
as$i)$L[]=$i->name;}return$L;}function
count_tables($ib){$L=array();return$L;}function
tables_list(){global$g;$Qa=array();foreach($g->executeCommand($g->_db_name,array('listCollections'=>1))as$K)$Qa[$K->name]='table';return$Qa;}function
drop_databases($ib){return
false;}function
indexes($S,$h=null){global$g;$L=array();foreach($g->executeCommand($g->_db_name,array('listIndexes'=>$S))as$t){$rb=array();$f=array();foreach(get_object_vars($t->key)as$e=>$bf){$rb[]=($bf==-1?'1':null);$f[]=$e;}$L[$t->name]=array("type"=>($t->name=="_id_"?"PRIMARY":(isset($t->unique)?"UNIQUE":"INDEX")),"columns"=>$f,"lengths"=>array(),"descs"=>$rb,);}return$L;}function
fields($S){global$j;$m=fields_from_edit();if(!$m){$K=$j->select($S,array("*"),null,null,array(),10);if($K){while($M=$K->fetch_assoc()){foreach($M
as$w=>$W){$M[$w]=null;$m[$w]=array("field"=>$w,"type"=>"string","null"=>($w!=$j->primary),"auto_increment"=>($w==$j->primary),"privileges"=>array("insert"=>1,"select"=>1,"update"=>1,),);}}}}return$m;}function
found_rows($T,$Z){global$g;$Z=where_to_query($Z);$Ve=$g->executeCommand($g->_db_name,array('count'=>$T['Name'],'query'=>$Z))->toArray();return$Ve[0]->n;}function
sql_query_where_parser($Td){$Td=preg_replace('~^\sWHERE \(?\(?(.+?)\)?\)?$~','\1',$Td);$yf=explode(' AND ',$Td);$zf=explode(') OR (',$Td);$Z=array();foreach($yf
as$wf)$Z[]=trim($wf);if(count($zf)==1)$zf=array();elseif(count($zf)>1)$Z=array();return
where_to_query($Z,$zf);}function
where_to_query($uf=array(),$vf=array()){global$b;$gb=array();foreach(array('and'=>$uf,'or'=>$vf)as$bf=>$Z){if(is_array($Z)){foreach($Z
as$Ob){list($Na,$E,$W)=explode(" ",$Ob,3);if($Na=="_id"&&preg_match('~^(MongoDB\\\\BSON\\\\ObjectID)\("(.+)"\)$~',$W,$_)){list(,$d,$W)=$_;$W=new$d($W);}if(!in_array($E,$b->operators))continue;if(preg_match('~^\(f\)(.+)~',$E,$_)){$W=(float)$W;$E=$_[1];}elseif(preg_match('~^\(date\)(.+)~',$E,$_)){$jb=new
DateTime($W);$d='MongoDB\BSON\UTCDatetime';$W=new$d($jb->getTimestamp()*1000);$E=$_[1];}switch($E){case'=':$E='$eq';break;case'!=':$E='$ne';break;case'>':$E='$gt';break;case'<':$E='$lt';break;case'>=':$E='$gte';break;case'<=':$E='$lte';break;case'regex':$E='$regex';break;default:continue
2;}if($bf=='and')$gb['$and'][]=array($Na=>array($E=>$W));elseif($bf=='or')$gb['$or'][]=array($Na=>array($E=>$W));}}}return$gb;}$wd=array("=","!=",">","<",">=","<=","regex","(f)=","(f)!=","(f)>","(f)<","(f)>=","(f)<=","(date)=","(date)!=","(date)>","(date)<","(date)>=","(date)<=",);$vd='regex';}function
table($yc){return$yc;}function
idf_escape($yc){return$yc;}function
table_status($D="",$Sb=false){$L=array();foreach(tables_list()as$S=>$bf){$L[$S]=array("Name"=>$S);if($D==$S)return$L[$S];}return$L;}function
create_database($i,$Oa){return
true;}function
last_id(){global$g;return$g->last_id;}function
error(){global$g;return
h($g->error);}function
collations(){return
array();}function
logged_user(){global$b;$cb=$b->credentials();return$cb[1];}function
connect(){global$b;$g=new
Min_DB;list($P,$U,$I)=$b->credentials();$F=array();if($U.$I!=""){$F["username"]=$U;$F["password"]=$I;}$i=$b->database();if($i!="")$F["db"]=$i;if(($va=getenv("MONGO_AUTH_SOURCE")))$F["authSource"]=$va;$g->connect("mongodb://$P",$F);if($g->error)return$g->error;return$g;}function
alter_indexes($S,$pa){global$g;foreach($pa
as$W){list($bf,$D,$Q)=$W;if($Q=="DROP")$L=$g->_db->command(array("deleteIndexes"=>$S,"index"=>$D));else{$f=array();foreach($Q
as$e){$e=preg_replace('~ DESC$~','',$e,1,$Za);$f[$e]=($Za?-1:1);}$L=$g->_db->selectCollection($S)->ensureIndex($f,array("unique"=>($bf=="UNIQUE"),"name"=>$D,));}if($L['errmsg']){$g->error=$L['errmsg'];return
false;}}return
true;}function
support($Tb){return
preg_match("~database|indexes|descidx~",$Tb);}function
db_collation($i,$Pa){}function
information_schema(){}function
is_view($T){}function
convert_field($l){}function
unconvert_field($l,$L){return$L;}function
foreign_keys($S){return
array();}function
fk_support($T){}function
engines(){return
array();}function
alter_table($S,$D,$m,$bc,$Ta,$Fb,$Oa,$wa,$Ed){global$g;if($S==""){$g->_db->createCollection($D);return
true;}}function
drop_tables($Ie){global$g;foreach($Ie
as$S){$ce=$g->_db->selectCollection($S)->drop();if(!$ce['ok'])return
false;}return
true;}function
truncate_tables($Ie){global$g;foreach($Ie
as$S){$ce=$g->_db->selectCollection($S)->remove();if(!$ce['ok'])return
false;}return
true;}function
driver_config(){global$wd,$vd;return
array('possible_drivers'=>array("mongo","mongodb"),'jush'=>"mongo",'operators'=>$wd,'operator_regexp'=>$vd,'functions'=>array(),'grouping'=>array(),'edit_functions'=>array(array("json")),);}class
Adminer{var$operators=array("<=",">=");var$_values=array();function
name(){return"<a href='https://www.adminerevo.org'".target_blank()." id='h1'>".'Editor'."</a>";}function
credentials(){return
array(SERVER,$_GET["username"],get_password());}function
connectSsl(){}function
permanentLogin($bb=false){return
password_file($bb);}function
bruteForceKey(){return$_SERVER["REMOTE_ADDR"];}function
serverName($P){}function
database(){global$g;if($g){$ib=$this->databases(false);return(!$ib?$g->result("SELECT SUBSTRING_INDEX(CURRENT_USER, '@', 1)"):$ib[(information_schema($ib[0])?1:0)]);}}function
schemas(){return
schemas();}function
databases($Yb=true){return
get_databases($Yb);}function
queryTimeout(){return
5;}function
headers(){}function
csp(){return
csp();}function
head(){return
true;}function
css(){$L=array();$n="adminer.css";if(file_exists($n))$L[]=$n;return$L;}function
loginForm(){echo"<table cellspacing='0' class='layout'>\n",$this->loginFormField('username','<tr><th>'.'Používateľ'.'<td>','<input type="hidden" name="auth[driver]" value="server"><input name="auth[username]" id="username" value="'.h($_GET["username"]).'" autocomplete="username" autocapitalize="off">'.script("focus(qs('#username'));")),$this->loginFormField('password','<tr><th>'.'Heslo'.'<td>','<input type="password" name="auth[password]" autocomplete="current-password">'."\n"),"</table>\n","<p><input type='submit' value='".'Prihlásiť sa'."'>\n",checkbox("auth[permanent]",1,$_COOKIE["adminer_permanent"],'Trvalé prihlásenie')."\n";}function
loginFormField($D,$tc,$X){return$tc.$X;}function
login($Yc,$I){return
true;}function
tableName($Ge){return
h($Ge["Comment"]!=""?$Ge["Comment"]:$Ge["Name"]);}function
fieldName($l,$G=0){return
h(preg_replace('~\s+\[.*\]$~','',($l["comment"]!=""?$l["comment"]:$l["field"])));}function
selectLinks($Ge,$Q=""){$a=$Ge["Name"];if($Q!==null)echo'<p class="tabs"><a href="'.h(ME.'edit='.urlencode($a).$Q).'">'.'Nová položka'."</a>\n";}function
foreignKeys($S){return
foreign_keys($S);}function
backwardKeys($S,$Fe){$L=array();foreach(get_rows("SELECT TABLE_NAME, CONSTRAINT_NAME, COLUMN_NAME, REFERENCED_COLUMN_NAME
FROM information_schema.KEY_COLUMN_USAGE
WHERE TABLE_SCHEMA = ".q($this->database())."
AND REFERENCED_TABLE_SCHEMA = ".q($this->database())."
AND REFERENCED_TABLE_NAME = ".q($S)."
ORDER BY ORDINAL_POSITION",null,"")as$M)$L[$M["TABLE_NAME"]]["keys"][$M["CONSTRAINT_NAME"]][$M["COLUMN_NAME"]]=$M["REFERENCED_COLUMN_NAME"];foreach($L
as$w=>$W){$D=$this->tableName(table_status($w,true));if($D!=""){$ie=preg_quote($Fe);$oe="(:|\\s*-)?\\s+";$L[$w]["name"]=(preg_match("(^$ie$oe(.+)|^(.+?)$oe$ie\$)iu",$D,$_)?$_[2].$_[3]:$D);}else
unset($L[$w]);}return$L;}function
backwardKeysPrint($za,$M){foreach($za
as$S=>$ya){foreach($ya["keys"]as$Ra){$y=ME.'select='.urlencode($S);$r=0;foreach($Ra
as$e=>$W)$y.=where_link($r++,$e,$M[$W]);echo"<a href='".h($y)."'>".h($ya["name"])."</a>";$y=ME.'edit='.urlencode($S);foreach($Ra
as$e=>$W)$y.="&set".urlencode("[".bracket_escape($e)."]")."=".urlencode($M[$W]);echo"<a href='".h($y)."' title='".'Nová položka'."'>+</a> ";}}}function
selectQuery($J,$ze,$Rb=false){return"<!--\n".str_replace("--","--><!-- ",$J)."\n(".format_time($ze).")\n-->\n";}function
rowDescription($S){foreach(fields($S)as$l){if(preg_match("~varchar|character varying~",$l["type"]))return
idf_escape($l["field"]);}return"";}function
rowDescriptions($N,$dc){$L=$N;foreach($N[0]as$w=>$W){if(list($S,$s,$D)=$this->_foreignColumn($dc,$w)){$zc=array();foreach($N
as$M)$zc[$M[$w]]=q($M[$w]);$qb=$this->_values[$S];if(!$qb)$qb=get_key_vals("SELECT $s, $D FROM ".table($S)." WHERE $s IN (".implode(", ",$zc).")");foreach($N
as$C=>$M){if(isset($M[$w]))$L[$C][$w]=(string)$qb[$M[$w]];}}}return$L;}function
selectLink($W,$l){}function
selectVal($W,$y,$l,$zd){$L=$W;$y=h($y);if(preg_match('~blob|bytea~',$l["type"])&&!is_utf8($W)){$L=lang(array('%d bajt','%d bajty','%d bajtov'),strlen($zd));if(preg_match("~^(GIF|\xFF\xD8\xFF|\x89PNG\x0D\x0A\x1A\x0A)~",$zd))$L="<img src='$y' alt='$L'>";}if(like_bool($l)&&$L!="")$L=(preg_match('~^(1|t|true|y|yes|on)$~i',$W)?'áno':'nie');if($y)$L="<a href='$y'".(is_url($y)?target_blank():"").">$L</a>";if(!$y&&!like_bool($l)&&preg_match(number_type(),$l["type"]))$L="<div class='number'>$L</div>";elseif(preg_match('~date~',$l["type"]))$L="<div class='datetime'>$L</div>";return$L;}function
editVal($W,$l){if(preg_match('~date|timestamp~',$l["type"])&&$W!==null)return
preg_replace('~^(\d{2}(\d+))-(0?(\d+))-(0?(\d+))~','$6.$4.$1',$W);return$W;}function
selectColumnsPrint($O,$f){}function
selectSearchPrint($Z,$f,$u){$Z=(array)$_GET["where"];echo'<fieldset id="fieldset-search"><legend>'.'Vyhľadať'."</legend><div>\n";$Lc=array();foreach($Z
as$w=>$W)$Lc[$W["col"]]=$w;$r=0;$m=fields($_GET["select"]);foreach($f
as$D=>$pb){$l=$m[$D];if(preg_match("~enum~",$l["type"])||like_bool($l)){$w=$Lc[$D];$r--;echo"<div>".h($pb)."<input type='hidden' name='where[$r][col]' value='".h($D)."'>:",(like_bool($l)?" <select name='where[$r][val]'>".optionlist(array(""=>"",'nie','áno'),$Z[$w]["val"],true)."</select>":enum_input("checkbox"," name='where[$r][val][]'",$l,(array)$Z[$w]["val"],($l["null"]?0:null))),"</div>\n";unset($f[$D]);}elseif(is_array($F=$this->_foreignKeyOptions($_GET["select"],$D))){if($m[$D]["null"])$F[0]='('.'prázdne'.')';$w=$Lc[$D];$r--;echo"<div>".h($pb)."<input type='hidden' name='where[$r][col]' value='".h($D)."'><input type='hidden' name='where[$r][op]' value='='>: <select name='where[$r][val]'>".optionlist($F,$Z[$w]["val"],true)."</select></div>\n";unset($f[$D]);}}$r=0;foreach($Z
as$W){if(($W["col"]==""||$f[$W["col"]])&&"$W[col]$W[val]"!=""){echo"<div><select name='where[$r][col]'><option value=''>(".'kdekoľvek'.")".optionlist($f,$W["col"],true)."</select>",html_select("where[$r][op]",array(-1=>"")+$this->operators,$W["op"]),"<input type='search' name='where[$r][val]' value='".h($W["val"])."'>".script("mixin(qsl('input'), {onkeydown: selectSearchKeydown, onsearch: selectSearchSearch});",""),"<input type='image' src='".h(preg_replace("~\\?.*~","",ME)."?file=cross.gif&version=4.8.4")."' class='jsonly icon' title='",h('Odobrať'),"' alt='x'>".script('qsl(".icon").onclick = selectRemoveRow;',""),"</div>\n";$r++;}}echo"<div><select name='where[$r][col]'><option value=''>(".'kdekoľvek'.")".optionlist($f,null,true)."</select>",script("qsl('select').onchange = selectAddRow;",""),html_select("where[$r][op]",array(-1=>"")+$this->operators),"<input type='search' name='where[$r][val]'>",script("mixin(qsl('input'), {onchange: function () { this.parentNode.firstChild.onchange(); }, onsearch: selectSearchSearch});"),"<input type='image' src='".h(preg_replace("~\\?.*~","",ME)."?file=cross.gif&version=4.8.4")."' class='jsonly icon' title='",h('Odobrať'),"' alt='x'>",script('qsl(".icon").onclick = selectRemoveRow;',""),"</div>","</div></fieldset>\n";}function
selectOrderPrint($G,$f,$u){$yd=array();foreach($u
as$w=>$t){$G=array();foreach($t["columns"]as$W)$G[]=$f[$W];if(count(array_filter($G,'strlen'))>1&&$w!="PRIMARY")$yd[$w]=implode(", ",$G);}if($yd){echo'<fieldset><legend>'.'Zotriediť'."</legend><div>","<select name='index_order'>".optionlist(array(""=>"")+$yd,($_GET["order"][0]!=""?"":$_GET["index_order"]),true)."</select>","</div></fieldset>\n";}if($_GET["order"])echo"<div style='display: none;'>".hidden_fields(array("order"=>array(1=>reset($_GET["order"])),"desc"=>($_GET["desc"]?array(1=>1):array()),))."</div>\n";}function
selectLimitPrint($x){echo"<fieldset><legend>".'Limit'."</legend><div>";echo
html_select("limit",array("","50","100"),$x),"</div></fieldset>\n";}function
selectLengthPrint($Me){}function
selectActionPrint($u){echo"<fieldset><legend>".'Akcia'."</legend><div>","<input type='submit' value='".'Vypísať'."'>","</div></fieldset>\n";}function
selectCommandPrint(){return
true;}function
selectImportPrint(){return
true;}function
selectEmailPrint($Cb,$f){if($Cb){print_fieldset("email",'E-mail',$_POST["email_append"]);echo"<div>",script("qsl('div').onkeydown = partialArg(bodyKeydown, 'email');"),"<p>".'Odosielateľ'.": <input name='email_from' value='".h($_POST?$_POST["email_from"]:$_COOKIE["adminer_email"])."'>\n",'Predmet'.": <input name='email_subject' value='".h($_POST["email_subject"])."'>\n","<p><textarea name='email_message' rows='15' cols='75'>".h($_POST["email_message"].($_POST["email_append"]?'{$'."$_POST[email_addition]}":""))."</textarea>\n","<p>".script("qsl('p').onkeydown = partialArg(bodyKeydown, 'email_append');","").html_select("email_addition",$f,$_POST["email_addition"])."<input type='submit' name='email_append' value='".'Vložiť'."'>\n";echo"<p>".'Prílohy'.": <input type='file' name='email_files[]'>".script("qsl('input').onchange = emailFileChange;"),"<p>".(count($Cb)==1?'<input type="hidden" name="email_field" value="'.h(key($Cb)).'">':html_select("email_field",$Cb)),"<input type='submit' name='email' value='".'Odoslať'."'>".confirm(),"</div>\n","</div></fieldset>\n";}}function
selectColumnsProcess($f,$u){return
array(array(),array());}function
selectSearchProcess($m,$u){global$j;$L=array();foreach((array)$_GET["where"]as$w=>$Z){$Na=$Z["col"];$E=$Z["op"];$W=$Z["val"];if(($w<0?"":$Na).$W!=""){$Ua=array();foreach(($Na!=""?array($Na=>$m[$Na]):$m)as$D=>$l){if($Na!=""||is_numeric($W)||!preg_match(number_type(),$l["type"])){$D=idf_escape($D);if($Na!=""&&$l["type"]=="enum")$Ua[]=(in_array(0,$W)?"$D IS NULL OR ":"")."$D IN (".implode(", ",array_map('intval',$W)).")";else{$Ne=preg_match('~char|text|enum|set~',$l["type"]);$X=$this->processInput($l,(!$E&&$Ne&&preg_match('~^[^%]+$~',$W)?"%$W%":$W));$Ua[]=$j->convertSearch($D,$W,$l).($X=="NULL"?" IS".($E==">="?" NOT":"")." $X":(in_array($E,$this->operators)||$E=="="?" $E $X":($Ne?" LIKE $X":" IN (".str_replace(",","', '",$X).")")));if($w<0&&$W=="0")$Ua[]="$D IS NULL";}}}$L[]=($Ua?"(".implode(" OR ",$Ua).")":"1 = 0");}}return$L;}function
selectOrderProcess($m,$u){$Ac=$_GET["index_order"];if($Ac!="")unset($_GET["order"][1]);if($_GET["order"])return
array(idf_escape(reset($_GET["order"])).($_GET["desc"]?" DESC":""));foreach(($Ac!=""?array($u[$Ac]):$u)as$t){if($Ac!=""||$t["type"]=="INDEX"){$oc=array_filter($t["descs"]);$pb=false;foreach($t["columns"]as$W){if(preg_match('~date|timestamp~',$m[$W]["type"])){$pb=true;break;}}$L=array();foreach($t["columns"]as$w=>$W)$L[]=idf_escape($W).(($oc?$t["descs"][$w]:$pb)?" DESC":"");return$L;}}return
array();}function
selectLimitProcess(){return(isset($_GET["limit"])?$_GET["limit"]:"50");}function
selectLengthProcess(){return"100";}function
selectEmailProcess($Z,$dc){if($_POST["email_append"])return
true;if($_POST["email"]){$me=0;if($_POST["all"]||$_POST["check"]){$l=idf_escape($_POST["email_field"]);$Ce=$_POST["email_subject"];$B=$_POST["email_message"];preg_match_all('~\{\$([a-z0-9_]+)\}~i',"$Ce.$B",$A);$N=get_rows("SELECT DISTINCT $l".($A[1]?", ".implode(", ",array_map('idf_escape',array_unique($A[1]))):"")." FROM ".table($_GET["select"])." WHERE $l IS NOT NULL AND $l != ''".($Z?" AND ".implode(" AND ",$Z):"").($_POST["all"]?"":" AND ((".implode(") OR (",array_map('where_check',(array)$_POST["check"]))."))"));$m=fields($_GET["select"]);foreach($this->rowDescriptions($N,$dc)as$M){$ae=array('{\\'=>'{');foreach($A[1]as$W)$ae['{$'."$W}"]=$this->editVal($M[$W],$m[$W]);$Bb=$M[$_POST["email_field"]];if(is_mail($Bb)&&send_mail($Bb,strtr($Ce,$ae),strtr($B,$ae),$_POST["email_from"],$_FILES["email_files"]))$me++;}}cookie("adminer_email",$_POST["email_from"]);redirect(remove_from_uri(),lang(array('Bol odoslaný %d e-mail.','Boli odoslané %d e-maily.','Bolo odoslaných %d e-mailov.'),$me));}return
false;}function
selectQueryBuild($O,$Z,$q,$G,$x,$H){return"";}function
messageQuery($J,$Oe,$Rb=false){return" <span class='time'>".@date("H:i:s")."</span><!--\n".str_replace("--","--><!-- ",$J)."\n".($Oe?"($Oe)\n":"")."-->";}function
editRowPrint($S,$m,$M,$kf){}function
editFunctions($l){$L=array();if($l["null"]&&preg_match('~blob~',$l["type"]))$L["NULL"]='prázdne';$L[""]=($l["null"]||$l["auto_increment"]||like_bool($l)?"":"*");if(preg_match('~date|time~',$l["type"]))$L["now"]='teraz';if(preg_match('~_(md5|sha1)$~i',$l["field"],$_))$L[]=strtolower($_[1]);return$L;}function
editInput($S,$l,$c,$X){if($l["type"]=="enum"){$F=array();$ke=$X;if(isset($_GET["select"])){$F[-1]='originál';if($ke===null)$ke=-1;}if($l["null"]){$F[""]="NULL";if($X===null&&!isset($_GET["select"]))$ke="";}$F[0]='prázdne';preg_match_all("~'((?:[^']|'')*)'~",$l["length"],$A);foreach($A[1]as$r=>$W){$W=stripcslashes(str_replace("''","'",$W));$F[$r+1]=$W;if($X===$W)$ke=$r+1;}return"<select$c>".optionlist($F,(string)$ke,1)."</select>";}$F=$this->_foreignKeyOptions($S,$l["field"],$X);if($F!==null)return(is_array($F)?"<select$c>".optionlist($F,$X,true)."</select>":"<input value='".h($X)."'$c class='hidden'>"."<input value='".h($F)."' class='jsonly'>"."<div></div>".script("qsl('input').oninput = partial(whisper, '".ME."script=complete&source=".urlencode($S)."&field=".urlencode($l["field"])."&value=');
qsl('div').onclick = whisperClick;",""));if(like_bool($l))return'<input type="checkbox" value="1"'.(preg_match('~^(1|t|true|y|yes|on)$~i',$X)?' checked':'')."$c>";$uc="";if(preg_match('~time~',$l["type"]))$uc='HH:MM:SS';if(preg_match('~date|timestamp~',$l["type"]))$uc='d.m.[rrrr]'.($uc?" [$uc]":"");if($uc)return"<input value='".h($X)."'$c> ($uc)";if(preg_match('~_(md5|sha1)$~i',$l["field"]))return"<input type='password' value='".h($X)."'$c>";return'';}function
editHint($S,$l,$X){return(preg_match('~\s+(\[.*\])$~',($l["comment"]!=""?$l["comment"]:$l["field"]),$_)?h(" $_[1]"):'');}function
processInput($l,$X,$p=""){if($p=="now")return"$p()";$L=$X;if(preg_match('~date|timestamp~',$l["type"])&&preg_match('(^'.str_replace('\$1','(?P<p1>\d*)',preg_replace('~(\\\\\\$([2-6]))~','(?P<p\2>\d{1,2})',preg_quote('$6.$4.$1'))).'(.*))',$X,$_))$L=($_["p1"]!=""?$_["p1"]:($_["p2"]!=""?($_["p2"]<70?20:19).$_["p2"]:gmdate("Y")))."-$_[p3]$_[p4]-$_[p5]$_[p6]".end($_);$L=($l["type"]=="bit"&&preg_match('~^[0-9]+$~',$X)?$L:q($L));if($X==""&&like_bool($l))$L="'0'";elseif($X==""&&($l["null"]||!preg_match('~char|text~',$l["type"])))$L="NULL";elseif(preg_match('~^(md5|sha1)$~',$p))$L="$p($L)";return
unconvert_field($l,$L);}function
dumpOutput(){return
array();}function
dumpFormat(){return
array('csv'=>'CSV,','csv;'=>'CSV;','tsv'=>'TSV');}function
dumpDatabase($i){}function
dumpTable($S,$Be,$Ic=0){echo"\xef\xbb\xbf";}function
dumpData($S,$Be,$J){global$g;$K=$g->query($J,1);if($K){while($M=$K->fetch_assoc()){if($Be=="table"){dump_csv(array_keys($M));$Be="INSERT";}dump_csv($M);}}}function
dumpFilename($xc){return
friendly_url($xc);}function
dumpHeaders($xc,$id=false){$Pb="csv";header("Content-Type: text/csv; charset=utf-8");return$Pb;}function
importServerPath(){}function
homepage(){return
true;}function
navigation($hd){global$ca;echo'<h1>
',$this->name(),' <span class="version">',$ca,'</span>
<a href="https://www.adminerevo.org"',target_blank(),' id="version">',(version_compare($ca,$_COOKIE["adminer_version"])<0?h($_COOKIE["adminer_version"]):""),'</a>
</h1>
';if($hd=="auth"){$Xb=true;foreach((array)$_SESSION["pwds"]as$Y=>$qe){foreach($qe[""]as$U=>$I){if($I!==null){if($Xb){echo"<ul id='logins'>",script("mixin(qs('#logins'), {onmouseover: menuOver, onmouseout: menuOut});");$Xb=false;}echo"<li><a href='".h(auth_url($Y,"",$U))."'>".($U!=""?h($U):"<i>".'prázdne'."</i>")."</a>\n";}}}}else{$this->databasesPrint($hd);if($hd!="db"&&$hd!="ns"){$T=table_status('',true);if(!$T)echo"<p class='message'>".'Žiadne tabuľky.'."\n";else$this->tablesPrint($T);}}}function
databasesPrint($hd){}function
tablesPrint($Ie){echo"<ul id='tables'>",script("mixin(qs('#tables'), {onmouseover: menuOver, onmouseout: menuOut});");foreach($Ie
as$M){echo'<li>';$D=$this->tableName($M);if(isset($M["Engine"])&&$D!=""){echo"<a href='".h(ME).'select='.urlencode($M["Name"])."'".bold($_GET["select"]==$M["Name"]||$_GET["edit"]==$M["Name"],"select")." title='".'Vypísať dáta'."'>$D</a>\n","<a href='".h(ME).'select='.urlencode($M["Name"])."'".bold($_GET["select"]==$M["Name"]||$_GET["edit"]==$M["Name"],"")." title='".'Vypísať dáta'."'>$D</a>\n";}}echo"</ul>\n";}function
_foreignColumn($dc,$e){foreach((array)$dc[$e]as$cc){if(count($cc["source"])==1){$D=$this->rowDescription($cc["table"]);if($D!=""){$s=idf_escape($cc["target"][0]);return
array($cc["table"],$s,$D);}}}}function
_foreignKeyOptions($S,$e,$X=null){global$g;if(list($Ke,$s,$D)=$this->_foreignColumn(column_foreign_keys($S),$e)){$L=&$this->_values[$Ke];if($L===null){$T=table_status($Ke);$L=($T["Rows"]>1000?"":array(""=>"")+get_key_vals("SELECT $s, $D FROM ".table($Ke)." ORDER BY 2"));}if(!$L&&$X!==null)return$g->result("SELECT $D FROM ".table($Ke)." WHERE $s = ".q($X));return$L;}}}$b=(function_exists('adminer_object')?adminer_object():new
Adminer);$Va=driver_config();$Ld=$Va['possible_drivers'];$v=$Va['jush'];$cf=$Va['types'];$Ae=$Va['structured_types'];$jf=$Va['unsigned'];$wd=$Va['operators'];$vd=isset($Va['operator_regexp'])&&in_array($Va['operator_regexp'],$wd)?$Va['operator_regexp']:null;$jc=$Va['functions'];$mc=$Va['grouping'];$zb=$Va['edit_functions'];if($b->operators===null){$b->operators=$wd;$b->operator_regexp=$vd;}define("SERVER",$_GET[DRIVER]);define("DB",$_GET["db"]);define("ME",preg_replace('~\?.*~','',relative_uri()).'?'.(sid()?SID.'&':'').(SERVER!==null?DRIVER."=".urlencode(SERVER).'&':'').(isset($_GET["username"])?"username=".urlencode($_GET["username"]).'&':'').(DB!=""?'db='.urlencode(DB).'&'.(isset($_GET["ns"])?"ns=".urlencode($_GET["ns"])."&":""):''));$ca="4.8.4";function
page_header($Qe,$k="",$Fa=array(),$Re=""){global$ba,$ca,$b,$wb,$v;page_headers();if(is_ajax()&&$k){page_messages($k);exit;}$Se=$Qe.($Re!=""?": $Re":"");$Te=strip_tags($Se.(SERVER!=""&&SERVER!="localhost"?h(" - ".SERVER):"")." - ".$b->name());echo'<!DOCTYPE html>
<html lang="sk" dir="ltr">
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<meta name="robots" content="noindex">
<title>',$Te,'</title>
<link rel="stylesheet" type="text/css" href="',h(preg_replace("~\\?.*~","",ME)."?file=default.css&version=4.8.4"),'">
',script_src(preg_replace("~\\?.*~","",ME)."?file=functions.js&version=4.8.4");if($b->head()){echo'<link rel="shortcut icon" type="image/x-icon" href="',h(preg_replace("~\\?.*~","",ME)."?file=favicon.ico&version=4.8.4"),'">
<link rel="apple-touch-icon" href="',h(preg_replace("~\\?.*~","",ME)."?file=favicon.ico&version=4.8.4"),'">
';foreach($b->css()as$eb){echo'<link rel="stylesheet" type="text/css" href="',h($eb),'">
';}}echo'
<body class="ltr nojs editor">
';$n=get_temp_dir()."/adminer.version";if(!$_COOKIE["adminer_version"]&&file_exists($n)&&filemtime($n)+86400>time()){$qf=unserialize(file_get_contents($n));$_COOKIE["adminer_version"]=$qf["version"];}echo'<script',nonce(),'>
mixin(document.body, {onkeydown: bodyKeydown, onclick: bodyClick',(isset($_COOKIE["adminer_version"])?"":", onload: partial(verifyVersion, '$ca', '".js_escape(ME)."', '".get_token()."')");?>});
document.body.className = document.body.className.replace(/ nojs/, ' js');
var offlineMessage = '<?php echo
js_escape('Ste offline.'),'\';
var thousandsSeparator = \'',js_escape(' '),'\';
</script>

<div id="help" class="jush-',$v,' jsonly hidden"></div>
',script("mixin(qs('#help'), {onmouseover: function () { helpOpen = 1; }, onmouseout: helpMouseout});"),'
<div id="content">
';if($Fa!==null){$y=substr(preg_replace('~\b(username|db|ns)=[^&]*&~','',ME),0,-1);echo'<p id="breadcrumb"><a href="'.h($y?$y:".").'">'.$wb[DRIVER].'</a> &raquo; ';$y=substr(preg_replace('~\b(db|ns)=[^&]*&~','',ME),0,-1);$P=$b->serverName(SERVER);$P=($P!=""?$P:'Server');if($Fa===false)echo"$P\n";else{echo"<a href='".h($y)."' accesskey='1' title='Alt+Shift+1'>$P</a> &raquo; ";if($_GET["ns"]!=""||(DB!=""&&is_array($Fa)))echo'<a href="'.h($y."&db=".urlencode(DB).(support("scheme")?"&ns=":"")).'">'.h(DB).'</a> &raquo; ';if(is_array($Fa)){if($_GET["ns"]!="")echo'<a href="'.h(substr(ME,0,-1)).'">'.h($_GET["ns"]).'</a> &raquo; ';foreach($Fa
as$w=>$W){$pb=(is_array($W)?$W[1]:h($W));if($pb!="")echo"<a href='".h(ME."$w=").urlencode(is_array($W)?$W[0]:$W)."'>$pb</a> &raquo; ";}}echo"$Qe\n";}}echo"<h2>$Se</h2>\n","<div id='ajaxstatus' class='jsonly hidden'></div>\n";restart_session();page_messages($k);$ib=&get_session("dbs");if(DB!=""&&$ib&&!in_array(DB,$ib,true))$ib=null;stop_session();define("PAGE_HEADER",1);}function
page_headers(){global$b;header("Content-Type: text/html; charset=utf-8");header("Cache-Control: no-cache");header("X-Frame-Options: deny");header("X-XSS-Protection: 0");header("X-Content-Type-Options: nosniff");header("Referrer-Policy: origin-when-cross-origin");foreach($b->csp()as$db){$rc=array();foreach($db
as$w=>$W)$rc[]="$w $W";header("Content-Security-Policy: ".implode("; ",$rc));}$b->headers();}function
csp(){return
array(array("script-src"=>"'self' 'unsafe-inline' 'nonce-".get_nonce()."' 'strict-dynamic'","connect-src"=>"'self' https://api.github.com/repos/adminerevo/adminerevo/releases/latest","frame-src"=>"'self'","object-src"=>"'none'","base-uri"=>"'none'","form-action"=>"'self'",),);}function
get_nonce(){static$nd;if(!$nd)$nd=base64_encode(rand_string());return$nd;}function
page_messages($k){$lf=preg_replace('~^[^?]*~','',$_SERVER["REQUEST_URI"]);$gd=[];if(isset($_SESSION["messages"][$lf]))$gd=$_SESSION["messages"][$lf];if(count($gd)>0){echo"<div class='message'>".implode("</div>\n<div class='message'>",$gd)."</div>".script("messagesPrint();");unset($_SESSION["messages"][$lf]);}if($k)echo"<div class='error'>$k</div>\n";}function
page_footer($hd=""){global$b,$We;echo'</div>

';if($hd!="auth"){echo'<form action="" method="post">
<p class="logout">
<input type="submit" name="logout" value="Odhlásiť" id="logout">
<input type="hidden" name="token" value="',$We,'">
</p>
</form>
';}echo'<div id="menu">
';$b->navigation($hd);echo'</div>
',script("setupSubmitHighlight(document);"),script("setupCopyToClipboard(document);"),"</body>\n</html>";}function
int32($C){while($C>=2147483648)$C-=4294967296;while($C<=-2147483649)$C+=4294967296;return(int)$C;}function
long2str($V,$sf){$he='';foreach($V
as$W)$he.=pack('V',$W);if($sf)return
substr($he,0,end($V));return$he;}function
str2long($he,$sf){$V=array_values(unpack('V*',str_pad($he,4*ceil(strlen($he)/4),"\0")));if($sf)$V[]=strlen($he);return$V;}function
xxtea_mx($Bf,$Af,$Ee,$Kc){return
int32((($Bf>>5&0x7FFFFFF)^$Af<<2)+(($Af>>3&0x1FFFFFFF)^$Bf<<4))^int32(($Ee^$Af)+($Kc^$Bf));}function
encrypt_string($_e,$w){if($_e=="")return"";$w=array_values(unpack("V*",pack("H*",md5($w))));$V=str2long($_e,true);$C=count($V)-1;$Bf=$V[$C];$Af=$V[0];$Rd=floor(6+52/($C+1));$Ee=0;while($Rd-->0){$Ee=int32($Ee+0x9E3779B9);$yb=$Ee>>2&3;for($Ad=0;$Ad<$C;$Ad++){$Af=$V[$Ad+1];$jd=xxtea_mx($Bf,$Af,$Ee,$w[$Ad&3^$yb]);$Bf=int32($V[$Ad]+$jd);$V[$Ad]=$Bf;}$Af=$V[0];$jd=xxtea_mx($Bf,$Af,$Ee,$w[$Ad&3^$yb]);$Bf=int32($V[$C]+$jd);$V[$C]=$Bf;}return
long2str($V,false);}function
decrypt_string($_e,$w){if($_e=="")return"";if(!$w)return
false;$w=array_values(unpack("V*",pack("H*",md5($w))));$V=str2long($_e,false);$C=count($V)-1;$Bf=$V[$C];$Af=$V[0];$Rd=floor(6+52/($C+1));$Ee=int32($Rd*0x9E3779B9);while($Ee){$yb=$Ee>>2&3;for($Ad=$C;$Ad>0;$Ad--){$Bf=$V[$Ad-1];$jd=xxtea_mx($Bf,$Af,$Ee,$w[$Ad&3^$yb]);$Af=int32($V[$Ad]-$jd);$V[$Ad]=$Af;}$Bf=$V[$C];$jd=xxtea_mx($Bf,$Af,$Ee,$w[$Ad&3^$yb]);$Af=int32($V[0]-$jd);$V[0]=$Af;$Ee=int32($Ee-0x9E3779B9);}return
long2str($V,true);}$g='';$qc=$_SESSION["token"];if(!$qc)$_SESSION["token"]=rand(1,1e6);$We=get_token();$Id=array();if($_COOKIE["adminer_permanent"]){foreach(explode(" ",$_COOKIE["adminer_permanent"])as$W){list($w)=explode(":",$W);$Id[$w]=$W;}}function
validate_server_input(){if(SERVER=="")return;$Fd=parse_url(SERVER);if(!$Fd)auth_error('Neplatný server alebo prihlasovacie údaje.');if(isset($Fd['user'])||isset($Fd['pass'])||isset($Fd['query'])||isset($Fd['fragment']))auth_error('Neplatný server alebo prihlasovacie údaje.');if(isset($Fd['scheme'])&&!preg_match('~^(https?)$~i',$Fd['scheme']))auth_error('Neplatný server alebo prihlasovacie údaje.');$vc=(isset($Fd['host'])?$Fd['host']:'').(isset($Fd['path'])?$Fd['path']:'');if(strpos(rtrim($vc,'/'),'/')!==false)auth_error('Neplatný server alebo prihlasovacie údaje.');if(isset($Fd['port'])&&($Fd['port']<1024||$Fd['port']>65535))auth_error('Pripojenie k privilegovaným portom nie je povolené.');}function
build_http_url($P,$U,$I,$ob,$nb=null){if(!preg_match('~^(https?://)?([^:]*)(:\d+)?$~',rtrim($P,'/'),$A)){$this->error='Neplatný server alebo prihlasovacie údaje.';return
false;}return($A[1]?:"http://").($U!==""||$I!==""?"$U:$I@":"").($A[2]!==""?$A[2]:$ob).(isset($A[3])?$A[3]:($nb?":$nb":""));}function
add_invalid_login(){global$b;$o=file_open_lock(get_temp_dir()."/adminer.invalid");if(!$o)return;$Fc=unserialize(stream_get_contents($o));$Oe=time();if($Fc){foreach($Fc
as$Gc=>$W){if($W[0]<$Oe)unset($Fc[$Gc]);}}$Ec=&$Fc[$b->bruteForceKey()];if(!$Ec)$Ec=array($Oe+30*60,0);$Ec[1]++;file_write_unlock($o,serialize($Fc));}function
check_invalid_login(){global$b;$Fc=unserialize(@file_get_contents(get_temp_dir()."/adminer.invalid"));$Ec=($Fc?$Fc[$b->bruteForceKey()]:array());if($Ec===null)return;$md=($Ec[1]>29?$Ec[0]-time():0);if($md>0)auth_error(lang(array('Príliš veľa pokusov o prihlásenie, skúste to znova za %d minutu.','Príliš veľa pokusov o prihlásenie, skúste to znova za %d minuty.','Príliš veľa pokusov o prihlásenie, skúste to znova za %d minút.'),ceil($md/60)));}$ua=$_POST["auth"];if($ua){session_regenerate_id();$Y=$ua["driver"];$P=trim($ua["server"]);$U=$ua["username"];$I=(string)$ua["password"];$i=$ua["db"];set_password($Y,$P,$U,$I);$_SESSION["db"][$Y][$P][$U][$i]=true;if($ua["permanent"]){$w=base64_encode($Y)."-".base64_encode($P)."-".base64_encode($U)."-".base64_encode($i);$Pd=$b->permanentLogin(true);$Id[$w]="$w:".base64_encode($Pd?encrypt_string($I,$Pd):"");cookie("adminer_permanent",implode(" ",$Id));}if(count($_POST)==1||DRIVER!=$Y||SERVER!=$P||$_GET["username"]!==$U||DB!=$i)redirect(auth_url($Y,$P,$U,$i));}elseif($_POST["logout"]&&(!$qc||verify_token())){foreach(array("pwds","db","dbs","queries")as$w)set_session($w,null);unset_permanent();redirect(substr(preg_replace('~\b(username|db|ns)=[^&]*&~','',ME),0,-1),'Odhlásenie prebehlo v poriadku.');}elseif($Id&&!$_SESSION["pwds"]){session_regenerate_id();$Pd=$b->permanentLogin();foreach($Id
as$w=>$W){list(,$Ka)=explode(":",$W);list($Y,$P,$U,$i)=array_map('base64_decode',explode("-",$w));set_password($Y,$P,$U,decrypt_string(base64_decode($Ka),$Pd));$_SESSION["db"][$Y][$P][$U][$i]=true;}}function
unset_permanent(){global$Id;foreach($Id
as$w=>$W){list($Y,$P,$U,$i)=array_map('base64_decode',explode("-",$w));if($Y==DRIVER&&$P==SERVER&&$U==$_GET["username"]&&$i==DB)unset($Id[$w]);}cookie("adminer_permanent",implode(" ",$Id));}function
auth_error($k){global$b,$qc;$re=session_name();if(isset($_GET["username"])){header("HTTP/1.1 403 Forbidden");if(($_COOKIE[$re]||$_GET[$re])&&!$qc)$k='Session vypršala, prihláste sa prosím znova.';else{restart_session();add_invalid_login();$I=get_password();if($I!==null){if($I===false)$k.=($k?'<br>':'').sprintf('Platnosť hlavného hesla vypršala. <a href="https://www.adminer.org/cs/extension/"%s>Implementujte</a> metodu %s, aby platilo natrvalo.',target_blank(),'<code>permanentLogin()</code>');set_password(DRIVER,SERVER,$_GET["username"],null);}unset_permanent();}}if(!$_COOKIE[$re]&&$_GET[$re]&&ini_bool("session.use_only_cookies"))$k='Session premenné musia byť povolené.';$Dd=session_get_cookie_params();cookie("adminer_key",($_COOKIE["adminer_key"]?$_COOKIE["adminer_key"]:rand_string()),$Dd["lifetime"]);page_header('Prihlásiť sa',$k,null);echo"<form action='' method='post'>\n","<div>";if(hidden_fields($_POST,array("auth")))echo"<p class='message'>".'Akcia sa vykoná po úspešnom prihlásení s rovnakými prihlasovacími údajmi.'."\n";echo"</div>\n";$b->loginForm();echo"</form>\n";page_footer("auth");exit;}if(isset($_GET["username"])&&!class_exists("Min_DB")){unset($_SESSION["pwds"][DRIVER]);unset_permanent();page_header('Žiadne rozšírenie',sprintf('Nie je dostupné žiadne z podporovaných rozšírení (%s).',implode(", ",$Ld)),false);page_footer("auth");exit;}stop_session(true);if(isset($_GET["username"])&&is_string(get_password())){validate_server_input();check_invalid_login();$g=connect();$j=new
Min_Driver($g);}$Yc=null;if(!is_object($g)||($Yc=$b->login($_GET["username"],get_password()))!==true){$k=(is_string($g)?h($g):(is_string($Yc)?$Yc:'Neplatný server alebo prihlasovacie údaje.'));auth_error($k.(preg_match('~^ | $~',get_password())?'<br>'.'V zadanom hesle je medzera, ktorá môže byť príčinou.':''));}if($_POST["logout"]&&$qc&&!verify_token()){page_header('Odhlásiť','Neplatný token CSRF. Odošlite formulár znova.');page_footer("db");exit;}if($ua&&$_POST["token"])$_POST["token"]=$We;$k='';if($_POST){if(!verify_token()){$Bc="max_input_vars";$ed=ini_get($Bc);if(extension_loaded("suhosin")){foreach(array("suhosin.request.max_vars","suhosin.post.max_vars")as$w){$W=ini_get($w);if($W&&(!$ed||$W<$ed)){$Bc=$w;$ed=$W;}}}$k=(!$_POST["token"]&&$ed?sprintf('Bol prekročený maximálny počet povolených polí. Zvýšte prosím %s.',"'$Bc'"):'Neplatný token CSRF. Odošlite formulár znova.'.' '.'Pokiaľ ste tento požiadavok neodoslali z Adminera, zatvorte túto stránku.');}}elseif($_SERVER["REQUEST_METHOD"]=="POST"){$k=sprintf('Príliš veľké POST dáta. Zmenšite dáta alebo zvýšte hodnotu konfiguračej direktívy %s.',"'post_max_size'");if(isset($_GET["sql"]))$k.=' '.'Veľký SQL soubor môžete nahrať pomocou FTP a importovať ho zo servera.';}function
email_header($rc){return"=?UTF-8?B?".base64_encode($rc)."?=";}function
send_mail($Bb,$Ce,$B,$ic="",$Vb=array()){$Hb=(DIRECTORY_SEPARATOR=="/"?"\n":"\r\n");$B=str_replace("\n",$Hb,wordwrap(str_replace("\r","","$B\n")));$Ea=uniqid("boundary");$ta="";foreach((array)$Vb["error"]as$w=>$W){if(!$W)$ta.="--$Ea$Hb"."Content-Type: ".str_replace("\n","",$Vb["type"][$w]).$Hb."Content-Disposition: attachment; filename=\"".preg_replace('~["\n]~','',$Vb["name"][$w])."\"$Hb"."Content-Transfer-Encoding: base64$Hb$Hb".chunk_split(base64_encode(file_get_contents($Vb["tmp_name"][$w])),76,$Hb).$Hb;}$Aa="";$sc="Content-Type: text/plain; charset=utf-8$Hb"."Content-Transfer-Encoding: 8bit";if($ta){$ta.="--$Ea--$Hb";$Aa="--$Ea$Hb$sc$Hb$Hb";$sc="Content-Type: multipart/mixed; boundary=\"$Ea\"";}$sc.=$Hb."MIME-Version: 1.0$Hb"."X-Mailer: Adminer Editor".($ic?$Hb."From: ".str_replace("\n","",$ic):"");return
mail($Bb,email_header($Ce),$Aa.$B.$ta,$sc);}function
like_bool($l){return
preg_match("~bool|(tinyint|bit)\\(1\\)~",$l["full_type"]);}$g->select_db($b->database());$rd="RESTRICT|NO ACTION|CASCADE|SET NULL|SET DEFAULT";$wb[DRIVER]='Prihlásiť sa';if(isset($_GET["select"])&&($_POST["edit"]||$_POST["clone"])&&!$_POST["save"])$_GET["edit"]=$_GET["select"];if(isset($_GET["download"])){$a=$_GET["download"];$m=fields($a);header("Content-Type: application/octet-stream");header("Content-Disposition: attachment; filename=".friendly_url("$a-".implode("_",$_GET["where"])).".".friendly_url($_GET["field"]));$O=array(idf_escape($_GET["field"]));$K=$j->select($a,$O,array(where($_GET,$m)),$O);$M=($K?$K->fetch_row():array());echo$j->value($M[0],$m[$_GET["field"]]);exit;}elseif(isset($_GET["edit"])){$a=$_GET["edit"];$m=fields($a);$Z=(isset($_GET["select"])?($_POST["check"]&&count($_POST["check"])==1?where_check($_POST["check"][0],$m):""):where($_GET,$m));$kf=(isset($_GET["select"])?$_POST["edit"]:$Z);foreach($m
as$D=>$l){if(!isset($l["privileges"][$kf?"update":"insert"])||$b->fieldName($l)==""||$l["generated"])unset($m[$D]);}if($_POST&&!$k&&!isset($_GET["select"])){$z=$_POST["referer"];if($_POST["insert"])$z=($kf?null:$_SERVER["REQUEST_URI"]);elseif(!preg_match('~^.+&select=.+$~',$z))$z=ME."select=".urlencode($a);$u=indexes($a);$ff=unique_array($_GET["where"],$u);$Ud="\nWHERE $Z";if(isset($_POST["delete"]))queries_redirect($z,'Položka bola vymazaná.',$j->delete($a,$Ud,!$ff));else{$Q=array();foreach($m
as$D=>$l){$W=process_input($l);if($W!==false&&$W!==null)$Q[idf_escape($D)]=$W;}if($kf){if(!$Q)redirect($z);queries_redirect($z,'Položka bola aktualizovaná.',$j->update($a,$Q,$Ud,!$ff));if(is_ajax()){page_headers();page_messages($k);exit;}}else{$K=$j->insert($a,$Q);$Rc=($K?last_id():0);queries_redirect($z,sprintf('Položka%s bola vložená.',($Rc?" $Rc":"")),$K);}}}$M=null;if($_POST["save"])$M=(array)$_POST["fields"];elseif($Z){$O=array();foreach($m
as$D=>$l){if(isset($l["privileges"]["select"])){$ra=convert_field($l);if($_POST["clone"]&&$l["auto_increment"])$ra="''";if($v=="sql"&&preg_match("~enum|set~",$l["type"]))$ra="1*".idf_escape($D);$O[]=($ra?"$ra AS ":"").idf_escape($D);}}$M=array();if(!support("table"))$O=array("*");if($O){$K=$j->select($a,$O,array($Z),$O,array(),(isset($_GET["select"])?2:1));if(!$K)$k=error();else{$M=$K->fetch_assoc();if(!$M)$M=false;}if(isset($_GET["select"])&&(!$M||$K->fetch_assoc()))$M=null;}}if(!support("table")&&!$m){if(!$Z){$K=$j->select($a,array("*"),$Z,array("*"));$M=($K?$K->fetch_assoc():false);if(!$M)$M=array($j->primary=>"");}if($M){foreach($M
as$w=>$W){if(!$Z)$M[$w]=null;$m[$w]=array("field"=>$w,"null"=>($w!=$j->primary),"auto_increment"=>($w==$j->primary));}}}edit_form($a,$m,$M,$kf);}elseif(isset($_GET["select"])){$a=$_GET["select"];$T=table_status1($a);$u=indexes($a);$m=fields($a);$fc=column_foreign_keys($a);$qd=$T["Oid"];parse_str($_COOKIE["adminer_import"],$ma);$ge=array();$f=array();$Me=null;foreach($m
as$w=>$l){$D=$b->fieldName($l);if(isset($l["privileges"]["select"])&&$D!=""){$f[$w]=html_entity_decode(strip_tags($D),ENT_QUOTES);if(is_shortable($l))$Me=$b->selectLengthProcess();}$ge+=$l["privileges"];}list($O,$q)=$b->selectColumnsProcess($f,$u);$Hc=count($q)<count($O)||strstr($O[0],"DISTINCT");$Z=$b->selectSearchProcess($m,$u);$G=$b->selectOrderProcess($m,$u);$x=$b->selectLimitProcess();if($_GET["val"]&&is_ajax()){header("Content-Type: text/plain; charset=utf-8");foreach($_GET["val"]as$gf=>$M){$ra=convert_field($m[key($M)]);$O=array($ra?$ra:idf_escape(key($M)));$Z[]=where_check($gf,$m);$L=$j->select($a,$O,$Z,$O);if($L)echo
reset($L->fetch_row());}exit;}$Nd=$if=null;foreach($u
as$t){if($t["type"]=="PRIMARY"){$Nd=array_flip($t["columns"]);$if=($O?$Nd:array());foreach($if
as$w=>$W){if(in_array(idf_escape($w),$O))unset($if[$w]);}break;}}if($qd&&!$Nd){$Nd=$if=array($qd=>0);$u[]=array("type"=>"PRIMARY","columns"=>array($qd));}if($_POST&&!$k){$xf=$Z;if(!$_POST["all"]&&is_array($_POST["check"])){$Ja=array();foreach($_POST["check"]as$Ha)$Ja[]=where_check($Ha,$m);$xf[]="((".implode(") OR (",$Ja)."))";}$xf=($xf?"\nWHERE ".implode(" AND ",$xf):"");if($_POST["export"]){cookie("adminer_import","output=".urlencode($_POST["output"])."&format=".urlencode($_POST["format"]));dump_headers($a);$b->dumpTable($a,"");$ic=($O?implode(", ",$O):"*").convert_fields($f,$m,$O)."\nFROM ".table($a);$lc=($q&&$Hc?"\nGROUP BY ".implode(", ",$q):"").($G?"\nORDER BY ".implode(", ",$G):"");if(!is_array($_POST["check"])||$Nd)$J="SELECT $ic$xf$lc";else{$ef=array();foreach($_POST["check"]as$W)$ef[]="(SELECT".limit($ic,"\nWHERE ".($Z?implode(" AND ",$Z)." AND ":"").where_check($W,$m).$lc,1).")";$J=implode(" UNION ALL ",$ef);}$b->dumpData($a,"table",$J);exit;}if(!$b->selectEmailProcess($Z,$fc)){if($_POST["save"]||$_POST["delete"]){$K=true;$na=0;$Q=array();if(!$_POST["delete"]){foreach($f
as$D=>$W){$W=process_input($m[$D]);if($W!==null&&($_POST["clone"]||$W!==false))$Q[idf_escape($D)]=($W!==false?$W:idf_escape($D));}}if($_POST["delete"]||$Q){if($_POST["clone"])$J="INTO ".table($a)." (".implode(", ",array_keys($Q)).")\nSELECT ".implode(", ",$Q)."\nFROM ".table($a);if($_POST["all"]||($Nd&&is_array($_POST["check"]))||$Hc){$K=($_POST["delete"]?$j->delete($a,$xf):($_POST["clone"]?queries("INSERT $J$xf"):$j->update($a,$Q,$xf)));$na=$g->affected_rows;}else{foreach((array)$_POST["check"]as$W){$tf="\nWHERE ".($Z?implode(" AND ",$Z)." AND ":"").where_check($W,$m);$K=($_POST["delete"]?$j->delete($a,$tf,1):($_POST["clone"]?queries("INSERT".limit1($a,$J,$tf)):$j->update($a,$Q,$tf,1)));if(!$K)break;$na+=$g->affected_rows;}}}$B=sprintf('%d položiek bolo ovplyvnených.',$na);if($_POST["clone"]&&$K&&$na==1){$Rc=last_id();if($Rc)$B=sprintf('Položka%s bola vložená.'," $Rc");}queries_redirect(remove_from_uri($_POST["all"]&&$_POST["delete"]?"page":""),$B,$K);if(!$_POST["delete"]){edit_form($a,$m,(array)$_POST["fields"],!$_POST["clone"]);page_footer();exit;}}elseif(!$_POST["import"]){if(!$_POST["val"])$k='Ctrl+kliknite na políčko, ktoré chcete zmeniť.';else{$K=true;$na=0;foreach($_POST["val"]as$gf=>$M){$Q=array();foreach($M
as$w=>$W){$w=bracket_escape($w,1);$Q[idf_escape($w)]=(preg_match('~char|text~',$m[$w]["type"])||$W!=""?$b->processInput($m[$w],$W):"NULL");}$K=$j->update($a,$Q," WHERE ".($Z?implode(" AND ",$Z)." AND ":"").where_check($gf,$m),!$Hc&&!$Nd," ");if(!$K)break;$na+=$g->affected_rows;}queries_redirect(remove_from_uri(),sprintf('%d položiek bolo ovplyvnených.',$na),$K);}}elseif(!is_string($Ub=get_file("csv_file",true)))$k=upload_error($Ub);elseif(!preg_match('~~u',$Ub))$k='Súbor musí byť v kódovaní UTF-8.';else{cookie("adminer_import","output=".urlencode($ma["output"])."&format=".urlencode($_POST["separator"]));$K=true;$Ra=array_keys($m);preg_match_all('~(?>"[^"]*"|[^"\r\n]+)+~',$Ub,$A);$na=count($A[0]);$j->begin();$oe=($_POST["separator"]=="csv"?",":($_POST["separator"]=="tsv"?"\t":";"));$N=array();foreach($A[0]as$w=>$W){preg_match_all("~((?>\"[^\"]*\")+|[^$oe]*)$oe~",$W.$oe,$bd);if(!$w&&!array_diff($bd[1],$Ra)){$Ra=$bd[1];$na--;}else{$Q=array();foreach($bd[1]as$r=>$Na)$Q[idf_escape($Ra[$r])]=($Na==""&&$m[$Ra[$r]]["null"]?"NULL":q(str_replace('""','"',preg_replace('~^"|"$~','',$Na))));$N[]=$Q;}}$K=(!$N||$j->insertUpdate($a,$N,$Nd));if($K)$K=$j->commit();queries_redirect(remove_from_uri("page"),lang(array('Bol importovaný %d záznam.','Boli importované %d záznamy.','Bolo importovaných %d záznamov.'),$na),$K);$j->rollback();}}}$He=$b->tableName($T);if(is_ajax()){page_headers();ob_start();}else
page_header('Vypísať'.": $He",$k);$Q=null;if(isset($ge["insert"])||!support("table")){$Q="";foreach((array)$_GET["where"]as$W){if($fc[$W["col"]]&&count($fc[$W["col"]])==1&&($W["op"]=="="||(!$W["op"]&&!preg_match('~[_%]~',$W["val"]))))$Q.="&set".urlencode("[".bracket_escape($W["col"])."]")."=".urlencode($W["val"]);}}$b->selectLinks($T,$Q);if(!$f&&support("table"))echo"<p class='error'>".'Tabuľku sa nepodarilo vypísať'.($m?".":": ".error())."\n";else{echo"<form action='' id='form'>\n","<div style='display: none;'>";hidden_fields_get();echo(DB!=""?'<input type="hidden" name="db" value="'.h(DB).'">'.(isset($_GET["ns"])?'<input type="hidden" name="ns" value="'.h($_GET["ns"]).'">':""):"");echo'<input type="hidden" name="select" value="'.h($a).'">','<input type="submit" value="'.h('Vypísať').'">';echo"</div>\n";$b->selectColumnsPrint($O,$f);$b->selectSearchPrint($Z,$f,$u);$b->selectOrderPrint($G,$f,$u);$b->selectLimitPrint($x);$b->selectLengthPrint($Me);$b->selectActionPrint($u);echo"</form>\n";$H=$_GET["page"];if($H=="last"){$hc=$g->result(count_rows($a,$Z,$Hc,$q));$H=floor(max(0,$hc-1)/$x);}$je=$O;$kc=$q;if(!$je){$je[]="*";$Ya=convert_fields($f,$m,$O);if($Ya)$je[]=substr($Ya,2);}foreach($O
as$w=>$W){$l=$m[idf_unescape($W)];if($l&&($ra=convert_field($l)))$je[$w]="$ra AS $W";}if(!$Hc&&$if){foreach($if
as$w=>$W){$je[]=idf_escape($w);if($kc)$kc[]=idf_escape($w);}}$K=$j->select($a,$je,$Z,$kc,$G,$x,$H,true);if(!$K)echo"<p class='error'>".error()."\n";else{if($v=="mssql"&&$H)$K->seek($x*$H);$Db=array();echo"<form action='' method='post' enctype='multipart/form-data'>\n";$N=array();while($M=$K->fetch_assoc()){if($H&&$v=="oracle")unset($M["RNUM"]);$N[]=$M;}if($_GET["page"]!="last"&&$x!=""&&$q&&$Hc&&$v=="sql")$hc=$g->result(" SELECT FOUND_ROWS()");if(!$N)echo"<p class='message'>".'Žiadne riadky.'."\n";else{$_a=$b->backwardKeys($a,$He);echo"<div class='scrollable'>","<table id='table' cellspacing='0' class='nowrap checkable'>",script("mixin(qs('#table'), {onclick: tableClick, ondblclick: partialArg(tableClick, true), onkeydown: editingKeydown});"),"<thead><tr>".(!$q&&$O?"":"<td><input type='checkbox' id='all-page' class='jsonly'>".script("qs('#all-page').onclick = partial(formCheck, /check/);","")." <a href='".h($_GET["modify"]?remove_from_uri("modify"):$_SERVER["REQUEST_URI"]."&modify=1")."' title='".'Zmeniť'."' class='edit-all'>".'Zmeniť'."</a>");$kd=array();$jc=array();reset($O);$Wd=1;foreach($N[0]as$w=>$W){if(!isset($if[$w])){$W=$_GET["columns"][key($O)]??null;$l=$m[$O?($W?$W["col"]:current($O)):$w];$D=($l?$b->fieldName($l,$Wd):($W["fun"]?"*":$w));if($D!=""){$Wd++;$kd[$w]=$D;$e=idf_escape($w);$wc=remove_from_uri('(order|desc)[^=]*|page').'&order%5B0%5D='.urlencode($w);$pb="&desc%5B0%5D=1";echo"<th id='th[".h(bracket_escape($w))."]'>".script("mixin(qsl('th'), {onmouseover: partial(columnMouse), onmouseout: partial(columnMouse, ' hidden')});",""),'<a href="'.h($wc.($G[0]==$e||$G[0]==$w||(!$G&&$Hc&&$q[0]==$e)?$pb:'')).'">';echo
apply_sql_function($W["fun"]??null,$D)."</a>";echo"<span class='column hidden'>","<a href='".h($wc.$pb)."' title='".'zostupne'."' class='text'> ↓</a>";if(isset($W["fun"])===false){echo'<a href="#fieldset-search" title="'.'Vyhľadať'.'" class="text jsonly"> =</a>',script("qsl('a').onclick = partial(selectSearch, '".js_escape($w)."');");}echo"</span>";}$jc[$w]=$W["fun"]??null;next($O);}}$Uc=array();if($_GET["modify"]){foreach($N
as$M){foreach($M
as$w=>$W)$Uc[$w]=max($Uc[$w],min(40,strlen(utf8_decode($W))));}}echo($_a?"<th>".'Vzťahy':"")."</thead>\n";if(is_ajax()){if($x%2==1&&$H%2==1)odd();ob_end_clean();}foreach($b->rowDescriptions($N,$fc)as$C=>$M){$ff=unique_array($N[$C],$u);if(!$ff){$ff=array();foreach($N[$C]as$w=>$W){if(!preg_match('~^(COUNT\((\*|(DISTINCT )?`(?:[^`]|``)+`)\)|(AVG|GROUP_CONCAT|MAX|MIN|SUM)\(`(?:[^`]|``)+`\))$~',$w))$ff[$w]=$W;}}$gf="";foreach($ff
as$w=>$W){if(($v=="sql"||$v=="pgsql")&&preg_match('~char|text|enum|set~',$m[$w]["type"])&&strlen($W)>64){$w=(strpos($w,'(')?$w:idf_escape($w));$w="MD5(".($v!='sql'||preg_match("~^utf8~",$m[$w]["collation"])?$w:"CONVERT($w USING ".charset($g).")").")";$W=md5($W);}$gf.="&".($W!==null?urlencode("where[".bracket_escape($w)."]")."=".urlencode($W===false?"f":$W):"null%5B%5D=".urlencode($w));}echo"<tr".odd().">".(!$q&&$O?"":"<td>".checkbox("check[]",substr($gf,1),in_array(substr($gf,1),(array)$_POST["check"])).($Hc||information_schema(DB)?"":" <a href='".h(ME."edit=".urlencode($a).$gf)."' class='edit' title='".'upraviť'."'>".'upraviť'."</a>"));foreach($M
as$w=>$W){if(isset($kd[$w])){$l=$m[$w];$W=$j->value($W,$l);if($W!=""&&(!isset($Db[$w])||$Db[$w]!=""))$Db[$w]=(is_mail($W)?$kd[$w]:"");$y="";if(preg_match('~blob|bytea|raw|file~',$l["type"]??null)&&$W!="")$y=ME.'download='.urlencode($a).'&field='.urlencode($w).$gf;if(!$y&&$W!==null){foreach((array)$fc[$w]as$ec){if(count($fc[$w])==1||end($ec["source"])==$w){$y="";foreach($ec["source"]as$r=>$xe)$y.=where_link($r,$ec["target"][$r],$N[$C][$xe]);$y=($ec["db"]!=""?preg_replace('~([?&]db=)[^&]+~','\1'.urlencode($ec["db"]),ME):ME).'select='.urlencode($ec["table"]).$y;if($ec["ns"])$y=preg_replace('~([?&]ns=)[^&]+~','\1'.urlencode($ec["ns"]),$y);if(count($ec["source"])==1)break;}}}if($w=="COUNT(*)"){$y=ME."select=".urlencode($a);$r=0;foreach((array)$_GET["where"]as$V){if(!array_key_exists($V["col"],$ff))$y.=where_link($r++,$V["col"],$V["val"],$V["op"]);}foreach($ff
as$Kc=>$V)$y.=where_link($r++,$Kc,$V);}$W=select_value($W,$y,$l,$Me);$s=h("val[$gf][".bracket_escape($w)."]");$X=null;if(isset($_POST["val"][$gf][bracket_escape($w)]))$_POST["val"][$gf][bracket_escape($w)];$_b=!is_array($M[$w])&&is_utf8($W)&&$N[$C][$w]==$M[$w]&&!$jc[$w];$Le=preg_match('~text|lob~',$l["type"]??null);echo"<td id='$s'";if(($_GET["modify"]&&$_b)||$X!==null){$nc=h($X!==null?$X:$M[$w]);echo">".($Le?"<textarea name='$s' cols='30' rows='".(substr_count($M[$w],"\n")+1)."'>$nc</textarea>":"<input name='$s' value='$nc' size='$Uc[$w]'>");}else{$Zc=strpos($W,"<i>…</i>");echo" data-text='".($Zc?2:($Le?1:0))."'".($_b?"":" data-warning='".h('Pre zmenu tejto hodnoty použite odkaz upraviť.')."'").">$W</td>";}}}if($_a)echo"<td>";$b->backwardKeysPrint($_a,$N[$C]);echo"</tr>\n";}if(is_ajax())exit;echo"</table>\n","</div>\n";}if(!is_ajax()){if($N||$H){$Mb=true;if($_GET["page"]!="last"){if($x==""||(count($N)<$x&&($N||!$H)))$hc=($H?$H*$x:0)+count($N);elseif($v!="sql"||!$Hc){$hc=($Hc?false:found_rows($T,$Z));if($hc<max(1e4,2*($H+1)*$x))$hc=reset(slow_query(count_rows($a,$Z,$Hc,$q)));else$Mb=false;}}$Bd=($x!=""&&($hc===false||$hc>$x||$H));if($Bd){echo(($hc===false?count($N)+1:$hc-$H*$x)>$x?'<p><a href="'.h(remove_from_uri("page")."&page=".($H+1)).'" class="loadmore">'.'Nahráť ďalšie dáta'.'</a>'.script("qsl('a').onclick = partial(selectLoadMore, ".(+$x).", '".'Nahráva sa'."…');",""):''),"\n";}}echo"<div class='footer'><div>\n";if($N||$H){if($Bd){$cd=($hc===false?$H+(count($N)>=$x?2:1):floor(($hc-1)/$x));echo"<fieldset>";if($v!="simpledb"){echo"<legend><a href='".h(remove_from_uri("page"))."'>".'Stránka'."</a></legend>",script("qsl('a').onclick = function () { pageClick(this.href, +prompt('".'Stránka'."', '".($H+1)."')); return false; };"),pagination(0,$H).($H>5?" …":"");for($r=max(1,$H-4);$r<min($cd,$H+5);$r++)echo
pagination($r,$H);if($cd>0){echo($H+5<$cd?" …":""),($Mb&&$hc!==false?pagination($cd,$H):" <a href='".h(remove_from_uri("page")."&page=last")."' title='~$cd'>".'posledný'."</a>");}}else{echo"<legend>".'Stránka'."</legend>",pagination(0,$H).($H>1?" …":""),($H?pagination($H,$H):""),($cd>$H?pagination($H+1,$H).($cd>$H+1?" …":""):"");}echo"</fieldset>\n";}echo"<fieldset>","<legend>".'Celý výsledok'."</legend>";$ub=($Mb?"":"~ ").$hc;echo
checkbox("all",1,0,($hc!==false?($Mb?"":"~ ").lang(array('%d riadok','%d riadky','%d riadkov'),$hc):""),"var checked = formChecked(this, /check/); selectCount('selected', this.checked ? '$ub' : checked); selectCount('selected2', this.checked || !checked ? '$ub' : checked);")."\n","</fieldset>\n";if($b->selectCommandPrint()){echo'<fieldset',($_GET["modify"]?'':' class="jsonly"'),'><legend>Zmeniť</legend><div>
<input type="submit" value="Uložiť"',($_GET["modify"]?'':' title="'.'Ctrl+kliknite na políčko, ktoré chcete zmeniť.'.'"'),'>
</div></fieldset>
<fieldset><legend>Označené <span id="selected"></span></legend><div>
<input type="submit" name="edit" value="Upraviť">
<input type="submit" name="clone" value="Klonovať">
<input type="submit" name="delete" value="Zmazať">',confirm(),'</div></fieldset>
';}$gc=$b->dumpFormat();foreach((array)$_GET["columns"]as$e){if($e["fun"]){unset($gc['sql']);break;}}if($gc){print_fieldset("export",'Export'." <span id='selected2'></span>");$_d=$b->dumpOutput();echo($_d?html_select("output",$_d,$ma["output"])." ":""),html_select("format",$gc,$ma["format"])," <input type='submit' name='export' value='".'Export'."'>\n","</div></fieldset>\n";}$b->selectEmailPrint(array_filter($Db,'strlen'),$f);}echo"</div></div>\n";if($b->selectImportPrint()){echo"<div>","<a href='#import'>".'Import'."</a>",script("qsl('a').onclick = partial(toggle, 'import');",""),"<span id='import' class='hidden'>: ","<input type='file' name='csv_file'> ",html_select("separator",array("csv"=>"CSV,","csv;"=>"CSV;","tsv"=>"TSV"),$ma["format"],1);echo" <input type='submit' name='import' value='".'Import'."'>","</span>","</div>";}echo"<input type='hidden' name='token' value='$We'>\n","</form>\n",(!$q&&$O?"":script("tableCheck();"));}}}if(is_ajax()){ob_end_clean();exit;}}elseif(isset($_GET["script"])){if($_GET["script"]=="kill")$g->query("KILL ".number($_POST["kill"]));elseif(list($S,$s,$D)=$b->_foreignColumn(column_foreign_keys($_GET["source"]),$_GET["field"])){$x=11;$K=$g->query("SELECT $s, $D FROM ".table($S)." WHERE ".(preg_match('~^[0-9]+$~',$_GET["value"])?"$s = $_GET[value] OR ":"")."$D LIKE ".q("$_GET[value]%")." ORDER BY 2 LIMIT $x");for($r=1;($M=$K->fetch_row())&&$r<$x;$r++)echo"<a href='".h(ME."edit=".urlencode($S)."&where".urlencode("[".bracket_escape(idf_unescape($s))."]")."=".urlencode($M[0]))."'>".h($M[1])."</a><br>\n";if($M)echo"...\n";}exit;}else{page_header('Server',"",false);if($b->homepage()){echo"<form action='' method='post'>\n","<p>".'Vyhľadať dáta v tabuľkách'.": <input type='search' name='query' value='".h($_POST["query"])."'> <input type='submit' value='".'Vyhľadať'."'>\n";if($_POST["query"]!="")search_tables();echo"<div class='scrollable'>\n","<table cellspacing='0' class='nowrap checkable'>\n",script("mixin(qsl('table'), {onclick: tableClick, ondblclick: partialArg(tableClick, true)});"),'<thead><tr class="wrap">','<td><input id="check-all" type="checkbox" class="jsonly">'.script("qs('#check-all').onclick = partial(formCheck, /^tables\[/);",""),'<th>'.'Tabuľka','<td>'.'Riadky',"</thead>\n";foreach(table_status()as$S=>$M){$D=$b->tableName($M);if(isset($M["Engine"])&&$D!=""){echo'<tr'.odd().'><td>'.checkbox("tables[]",$S,in_array($S,(array)$_POST["tables"],true)),"<th><a href='".h(ME).'select='.urlencode($S)."'>$D</a>";$W=format_number($M["Rows"]);echo"<td align='right'><a href='".h(ME."edit=").urlencode($S)."'>".($M["Engine"]=="InnoDB"&&$W?"~ $W":$W)."</a>";}}echo"</table>\n","</div>\n","</form>\n",script("tableCheck();");}}page_footer();